unit HCFConf;

interface

uses
  ShellAPI,
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  ExtCtrls,
  Menus,
  Registry,
  ComCtrls,
  Grids,
  jpeg,
  SyncObjs,
  CPort,
  Mask,
  RXShell,
  SwLevelBar,
  SwClasses,
  SwScope,
  Tapi,
  TapiDial,
  Buttons,
  Languages;

type
  THCFForm = class(TForm)
    SaveBut: TButton;
    ResetBut: TButton;
    ExitBut: TButton;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Options1: TMenuItem;
    Help: TMenuItem;
    Help_Index: TMenuItem;
    Help_About: TMenuItem;
    File_Exit: TMenuItem;
    N2: TMenuItem;
    Options_PnP: TMenuItem;
    File_Save: TMenuItem;
    N3: TMenuItem;
    File_Reset: TMenuItem;
    ComPort1: TComPort;
    Options_Port: TMenuItem;
    COM11: TMenuItem;
    COM21: TMenuItem;
    COM31: TMenuItem;
    COM41: TMenuItem;
    SaveDialog: TSaveDialog;
    RxTrayIcon: TRxTrayIcon;
    PopupMenu1: TPopupMenu;
    Restore1: TMenuItem;
    Exit2: TMenuItem;
    PnP0000: TMenuItem;
    PnP0001: TMenuItem;
    PnP0002: TMenuItem;
    PnP0003: TMenuItem;
    PnP0004: TMenuItem;
    PnP0005: TMenuItem;
    File_Autodetection: TMenuItem;
    File_Savetofile: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    PnPCustom: TMenuItem;
    Options_Country: TMenuItem;
    Country0000: TMenuItem;
    Country0001: TMenuItem;
    Country0002: TMenuItem;
    Country0003: TMenuItem;
    Country0004: TMenuItem;
    Country0005: TMenuItem;
    N6: TMenuItem;
    CountryCustom: TMenuItem;
    N7: TMenuItem;
    SupportPage1: TMenuItem;
    SendEMail1: TMenuItem;
    COM51: TMenuItem;
    COM61: TMenuItem;
    View1: TMenuItem;
    Pages1: TMenuItem;
    MenInfo: TMenuItem;
    MenTransmit: TMenuItem;
    MenRegisters: TMenuItem;
    MenSignals: TMenuItem;
    MenTiming: TMenuItem;
    MenStatistics: TMenuItem;
    Pages: TPageControl;
    TabInfo: TTabSheet;
    TabTransmit: TTabSheet;
    TabRegisters: TTabSheet;
    TabSignals: TTabSheet;
    TabTiming: TTabSheet;
    TabMonitoring: TTabSheet;
    TabStatistics: TTabSheet;
    BottomPanel: TPanel;
    BevelRegisters: TBevel;
    BevelSignals: TBevel;
    BevelTiming: TBevel;
    BevelMonitoring: TBevel;
    BevelStatistics: TBevel;
    BevelInfo: TBevel;
    BevelTransmit: TBevel;
    CurCountryLab: TLabel;
    DrVerLab: TLabel;
    ModModelLab: TLabel;
    OemStLab: TLabel;
    HardLab: TLabel;
    CurCountryEdit: TEdit;
    DrVerEdit: TEdit;
    ModModelEdit: TEdit;
    OemStEdit: TEdit;
    HardEdit: TEdit;

// Transmit Page
    TXBox: TGroupBox;
      DataTXLabel: TLabel;
      FaxTXLabel: TLabel;
      VoiceTXLabel: TLabel;
      DataTXBox: TComboBox;
      FaxTXBox: TComboBox;
      VoiceTXBox: TComboBox;
    AggressivenessBox: TGroupBox;
      LineQualityBox: TComboBox;
      ProtocolBox: TComboBox;
      AggressivenessRadioBtn1: TRadioButton;
      AggressivenessRadioBtn2: TRadioButton;
      AggressivenessSpeedLabel: TLabel;
      Bevel4: TBevel;
      Bevel5: TBevel;
      CustomMaskL: TMaskEdit;
      CustomMaskR: TMaskEdit;
      PerCentLabel: TLabel;
      BLERLabel: TLabel;
      TenLabel: TLabel;
    ModulationBox: TGroupBox;
      ModNegCheckBox: TCheckBox;
      Label6: TLabel;
      ModProtocolBox: TComboBox;
      Bevel6: TBevel;
      Label11: TLabel;
      Label12: TLabel;
      Label7: TLabel;
      Label8: TLabel;
      Label9: TLabel;
      Label10: TLabel;
      ModTXMinBox: TComboBox;
      ModTXMaxBox: TComboBox;
      ModRXMinBox: TComboBox;
      ModRXMaxBox: TComboBox;

// Registers Page
    SregLimGrid: TStringGrid;
    SRegGrid: TStringGrid;

// Signals Page
    SignModeLabel: TLabel;
    SignPhLabel: TLabel;
    SignCyclLabel: TLabel;
    SignSignLabel: TLabel;
    ModeBox: TComboBox;
    PhasesBox: TComboBox;
    CyclesEdit: TEdit;
    SignalsBox: TComboBox;
    Bevel3: TBevel;
    SigGraph: TImage;
    Phase1Box: TGroupBox;
      P1MinONLab: TLabel;
      P1MaxONLab: TLabel;
      P1MinOFFLab: TLabel;
      P1MaxOFFLab: TLabel;
      P1MinON: TMaskEdit;
      P1MaxON: TMaskEdit;
      P1MinOFF: TMaskEdit;
      P1MaxOFF: TMaskEdit;
      P1ms1Lab: TLabel;
      P1ms2Lab: TLabel;
      P1ms3Lab: TLabel;
      P1ms4Lab: TLabel;
    Phase2Box: TGroupBox;
      P2MinONLab: TLabel;
      P2MaxONLab: TLabel;
      P2MinOFFLab: TLabel;
      P2MaxOFFLab: TLabel;
      P2MinON: TMaskEdit;
      P2MaxON: TMaskEdit;
      P2MinOFF: TMaskEdit;
      P2MaxOFF: TMaskEdit;
      P2ms1Lab: TLabel;
      P2ms2Lab: TLabel;
      P2ms3Lab: TLabel;
      P2ms4Lab: TLabel;

// Timing Page
    TimeDelayBox: TGroupBox;
    TimeDetectionBox: TGroupBox;
    Delay1Label: TLabel;
    Delay2Label: TLabel;
    Delay3Label: TLabel;
    Delay4Label: TLabel;
    Detect1Label: TLabel;
    Detect2Label: TLabel;
    Delay1ms: TLabel;
    Delay2ms: TLabel;
    Delay3ms: TLabel;
    Delay4ms: TLabel;
    Detect1ms: TLabel;
    Detect2ms: TLabel;
    Delay1Edit: TEdit;
    Delay2Edit: TEdit;
    Delay3Edit: TEdit;
    Delay4Edit: TEdit;
    Detect1Edit: TEdit;
    Detect2Edit: TEdit;

// Signals Page
    MemoStat: TMemo;
    AboutPanel: TPanel;
    AboutImage: TImage;
    AboutLabel: TLabel;
    TabBlacklist: TTabSheet;
    BevelBlacklisting: TBevel;
    MenBlacklist: TMenuItem;
    SwScope1: TSwScope;
    SwLevelBar1: TSwLevelBar;
    CPULabel: TLabel;
    TabInits: TTabSheet;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Bevel1: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Edit8: TEdit;
    Edit9: TEdit;
    Label5: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    Languages1: TMenuItem;
    Deutsch1: TMenuItem;
    Russian1: TMenuItem;
    English1: TMenuItem;
    OperationSystem1: TMenuItem;
    Win9XMe1: TMenuItem;
    WinNT20001: TMenuItem;
    MenInits: TMenuItem;
    MenMonitoring: TMenuItem;

    procedure Exit(Sender: TObject);
    procedure SaveTabs(Sender: TObject);
    procedure ResetTabs(Sender: TObject);
    procedure RegistersUpdate(Sender: TObject);
    procedure TXUpdate(Sender: TObject);
    procedure About(Sender: TObject);
    procedure NotReady(Sender: TObject);
    procedure COMChange(Sender: TObject);
    procedure ReadStat(Sender: TObject);
    procedure DeCodeStat(Sender: TObject);
    procedure SignUpdate(Sender: TObject);
    procedure PhasesBoxChange(Sender: TObject);
    procedure CadenceChange(Sender: TObject);
    procedure ModeBoxChange(Sender: TObject);
    procedure SignalsBoxChange(Sender: TObject);
    procedure ReadInfo(Sender: TObject);
    procedure Mail2Autor(Sender: TObject);
    procedure OpenSupportPage(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TrayForm(Sender: TObject);
    procedure ShowForm(Sender: TObject);
    procedure Initialize(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure PnPChange(Sender: TObject);
    procedure ReadTiming(Sender: TObject);
    procedure AggressivenessChange(Sender: TObject);
    procedure CalculateAggressiveness(Sender: TObject);
    procedure ShowHelp(Sender: TObject);
    procedure Autodetection(Sender: TObject);
    function Dec2Hex(DecInt: Integer; numbers: byte) : string;
    function D2H(Dec: Byte): char;
    procedure PnPCustomClick(Sender: TObject);
    procedure CountryChange(Sender: TObject);
    procedure CountryCustomClick(Sender: TObject);
    procedure ModProtocolBoxChange(Sender: TObject);
    procedure PagesVisible(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure ReadTabs(Sender: TObject);
    procedure LanguageLoading(Sender: TObject);
    procedure ReadInits(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

const
  SregZName: String = 'NVRamZBody';
  SregCName: String = 'NVRamBody';
  SregLimName: String = 'SREG';
  CntrName: String[10] = 'NAME';
  CntrTX: String[10] = 'TXLEVEL';
  CntrSpeed: String[12] = 'SPEEDADJUST';
  CadenceKey: String[10] = 'CADENCE';
  TimingKey: String[10] = 'TIMING';
  ToneKey: String[10] = 'TONE';
  ModemKey: String = '\System\CurrentControlSet\Services\Class\Modem\';
  CountryKey: String = '\Country\0000\';
  CountryWord: String = '\Country\';
  OEMKey: String = '\OEM\';

var
  HCFForm: THCFForm;
  Reg, MyRegistry: TRegistry;
  Events: TComEvents;
  Event: TEvent;
  Tap1: TTapiDial;
  Stat: String;
  ComPort: String[4] = 'COM3';
  PNP_Key: String[4] = '0000';
  Country_Key: String[4] = '0000';
  ResetButton: boolean = false;
  LimitGridRows: Integer = 0;
  RegistersGridRows: Integer = 0;
  PnPDetected: boolean = false;
  CntDetected: boolean = false;
  SpeedAdj: Array [0..2] of byte = (0, 0, 0);
  CanHideSplash: boolean = true;
  Tabs: String = '111111111';

implementation

{$R *.DFM}

procedure THCFForm.Exit(Sender: TObject);
begin
  HCFForm.Close;
end;

procedure THCFForm.SaveTabs(Sender: TObject);
var
  Data : Array of Byte;
  sz : Word;
  I, J, space: Integer;
  FilePath : string;
  TF : TextFile;
begin
  Reg := TRegistry.Create;
  Reg.RootKey := HKEY_LOCAL_MACHINE;
// Save Info To File
  if Pages.ActivePage.Name = 'TabInfo' then
  begin
    SaveDialog.Filter := 'Text files (*.txt)|*.TXT|Log files (*.log)|*.LOG|NotePad files (*.not)|*.NOT|All files (*.*)|*.*';
    SaveDialog.DefaultExt := 'txt';
    if SaveDialog.Execute then
    try
      FilePath := SaveDialog.FileName;
      AssignFile(TF, FilePath);
      Rewrite(TF);
      WriteLn(TF, 'DEVICE INFORMATION');
      WriteLn(TF, '');
      WriteLn(TF, 'Modem Model ............... ' + ModModelEdit.Text);
      WriteLn(TF, 'Current Country ........... ' + CurCountryEdit.Text);
      WriteLn(TF, 'Driver Version ............ ' + DrVerEdit.Text);
      WriteLn(TF, 'OEM String ................ ' + OemStEdit.Text);
      WriteLn(TF, 'Hardware ID ............... ' + HardEdit.Text);
      WriteLn(TF, 'Hidden Init #1 ............ ' + Edit1.Text);
      WriteLn(TF, 'Hidden Init #2 ............ ' + Edit2.Text);
      WriteLn(TF, 'Hidden Init #3 ............ ' + Edit3.Text);
      WriteLn(TF, 'User Init String .......... ' + Edit4.Text);
      WriteLn(TF, '');
      CloseFile(TF);
    except
      ShowMessage('Can''t save info!');
    end;
  end;


{
  Case  TabControl1.TabIndex of
    0: begin // Save Info To File
         SaveDialog.Filter := 'Text files (*.txt)|*.TXT|Log files (*.log)|*.LOG|NotePad files (*.not)|*.NOT|All files (*.*)|*.*';
         SaveDialog.DefaultExt := 'txt';
         If SaveDialog.Execute then
         Try
           FilePath := SaveDialog.FileName;
           AssignFile(TF, FilePath);
           Rewrite(TF);
           WriteLn(TF, 'DEVICE INFORMATION');
           WriteLn(TF, '');
           WriteLn(TF, 'Modem Model ............... ' + ModModelEdit.Text);
           WriteLn(TF, 'Current Country ........... ' + CurCountryEdit.Text);
           WriteLn(TF, 'Driver Version ............ ' + DrVerEdit.Text);
           WriteLn(TF, 'OEM String ................ ' + OemStEdit.Text);
           WriteLn(TF, 'Hardware ID ............... ' + HardEdit.Text);
           WriteLn(TF, 'RAS Init String ........... ' + InitStrEdit.Text);
           WriteLn(TF, '');
           CloseFile(TF);
         Except
           ShowMessage('Can''t save info!');
         End;
       end;
    1: begin // Save Transmitting Parameters
         Try
           Reg.OpenKey(ModemKey + PNP_Key + CountryWord + Country_Key, False);
           sz := Reg.GetDataSize(CntrTX);
           SetLength(Data, sz);
           Reg.ReadBinaryData(CntrTX, Data[0], sz);
           Data[2] := DataTXBox.ItemIndex;
           Data[5] := FaxTXBox.ItemIndex;
           Data[8] := VoiceTXBox.ItemIndex;
           Data[9] := 0;
           //If StrToInt(LowTXEdit.Text) < 0 then Data[10] := (-10)*StrToInt(LowTXEdit.Text) else Data[10] := (-10)*StrToInt(LowTXEdit.Text);
           //If StrToInt(HighTXEdit.Text) < 0 then Data[11] := (-10)*StrToInt(HighTXEdit.Text) else Data[11] := (-10)*StrToInt(LowTXEdit.Text);
           Reg.WriteBinaryData(CntrTX, Data[0], sz);
           Reg.WriteBinaryData(CntrSpeed, SpeedAdj[0], 3);
         Except
         End;
       end;
    2: begin // Save S-Registers Values
         SaveDialog.Filter := 'Text files (*.txt)|*.TXT|Log files (*.log)|*.LOG|NotePad files (*.not)|*.NOT|All files (*.*)|*.*';
         If SaveDialog.Execute then
         Try
           FilePath := SaveDialog.FileName;
           AssignFile(TF, FilePath);
           Rewrite(TF);
           WriteLn(TF, 'S-REGISTERS VALUES');
           WriteLn(TF, '');
           WriteLn(TF, 'S-Reg   Min   Max   Default');
           WriteLn(TF, '-----   ---   ---   -------');
           For I := 0 to LimitGridRows do
           begin
             Write(TF, SregLimGrid.Cells[0, I+1]);
             space := 8 - Length(SregLimGrid.Cells[0, I+1]);
             For J := 1 to space do Write(TF, ' ');
             Write(TF, SregLimGrid.Cells[1, I+1]);
             space := 6 - Length(SregLimGrid.Cells[1, I+1]);
             For J := 1 to space do Write(TF, ' ');
             Write(TF, SregLimGrid.Cells[2, I+1]);
             space := 6 - Length(SregLimGrid.Cells[2, I+1]);
             For J := 1 to space do Write(TF, ' ');
             WriteLn(TF, SregLimGrid.Cells[3, I+1]);
           end;
           WriteLn(TF, '');
           WriteLn(TF, 'S-Reg   Current   Stored');
           WriteLn(TF, '-----   -------   ------');
           For I := 0 to RegistersGridRows do
           begin
             Write(TF, SRegGrid.Cells[0, I+1]);
             space := 8 - Length(SRegGrid.Cells[0, I+1]);
             For J := 1 to space do Write(TF, ' ');
             Write(TF, SRegGrid.Cells[1, I+1]);
             space := 10 - Length(SRegGrid.Cells[1, I+1]);
             For J := 1 to space do Write(TF, ' ');
             WriteLn(TF, SRegGrid.Cells[2, I+1]);
           end;
           WriteLn(TF, '');
           CloseFile(TF);
         Except
           ShowMessage('Can''t save S-Registers values!');
         End;
       end;
    3: begin // Save Signals Cadence
         Try
           Case ModeBox.ItemIndex of
             0: Reg.OpenKey(ModemKey + PNP_Key + CountryWord + Country_Key, False);
             1: Reg.OpenKey(ModemKey + PNP_Key + OEMKey, False);
             else MessageDlg('Problems with saving current MODE parameters!', mtError, [mbOK], 0);
           end;
           sz := Reg.GetDataSize(CadenceKey);
           SetLength(Data, sz);
           Reg.ReadBinaryData(CadenceKey, Data[0], sz);
           Data[0] := PhasesBox.ItemIndex + 1;
           Case SignalsBox.ItemIndex of
             0: begin
                  Data[2] := StrToInt(P1MinON.Text) div 256;
                  Data[1] := StrToInt(P1MinON.Text) - Data[2]*256;
                  Data[6] := StrToInt(P1MaxON.Text) div 256;
                  Data[5] := StrToInt(P1MaxON.Text) - Data[6]*256;
                  Data[10] := StrToInt(P1MinOFF.Text) div 256;
                  Data[9] := StrToInt(P1MinOFF.Text) - Data[10]*256;
                  Data[14] := StrToInt(P1MaxOFF.Text) div 256;
                  Data[13] := StrToInt(P1MaxOFF.Text) - Data[14]*256;

                  Data[18] := StrToInt(P2MinON.Text) div 256;
                  Data[17] := StrToInt(P2MinON.Text) - Data[18]*256;
                  Data[22] := StrToInt(P2MaxON.Text) div 256;
                  Data[21] := StrToInt(P2MaxON.Text) - Data[22]*256;
                  Data[26] := StrToInt(P2MinOFF.Text) div 256;
                  Data[25] := StrToInt(P2MinOFF.Text) - Data[26]*256;
                  Data[30] := StrToInt(P2MaxOFF.Text) div 256;
                  Data[29] := StrToInt(P2MaxOFF.Text) - Data[30]*256;

                  Data[34] := StrToInt(CyclesEdit.Text) div 256;
                  Data[33] := StrToInt(CyclesEdit.Text) - Data[34]*256;
                end;
             1: begin
                  Data[38] := StrToInt(P1MinON.Text) div 256;
                  Data[37] := StrToInt(P1MinON.Text) - Data[38]*256;
                  Data[42] := StrToInt(P1MaxON.Text) div 256;
                  Data[41] := StrToInt(P1MaxON.Text) - Data[42]*256;
                  Data[46] := StrToInt(P1MinOFF.Text) div 256;
                  Data[45] := StrToInt(P1MinOFF.Text) - Data[46]*256;
                  Data[50] := StrToInt(P1MaxOFF.Text) div 256;
                  Data[49] := StrToInt(P1MaxOFF.Text) - Data[50]*256;

                  Data[54] := StrToInt(P2MinON.Text) div 256;
                  Data[53] := StrToInt(P2MinON.Text) - Data[54]*256;
                  Data[58] := StrToInt(P2MaxON.Text) div 256;
                  Data[57] := StrToInt(P2MaxON.Text) - Data[58]*256;
                  Data[62] := StrToInt(P2MinOFF.Text) div 256;
                  Data[61] := StrToInt(P2MinOFF.Text) - Data[62]*256;
                  Data[66] := StrToInt(P2MaxOFF.Text) div 256;
                  Data[65] := StrToInt(P2MaxOFF.Text) - Data[66]*256;

                  Data[70] := StrToInt(CyclesEdit.Text) div 256;
                  Data[69] := StrToInt(CyclesEdit.Text) - Data[70]*256;
                end;
             2: begin
                  Data[74] := StrToInt(P1MinON.Text) div 256;
                  Data[73] := StrToInt(P1MinON.Text) - Data[74]*256;
                  Data[78] := StrToInt(P1MaxON.Text) div 256;
                  Data[77] := StrToInt(P1MaxON.Text) - Data[78]*256;
                  Data[82] := StrToInt(P1MinOFF.Text) div 256;
                  Data[81] := StrToInt(P1MinOFF.Text) - Data[82]*256;
                  Data[86] := StrToInt(P1MaxOFF.Text) div 256;
                  Data[85] := StrToInt(P1MaxOFF.Text) - Data[86]*256;

                  Data[90] := StrToInt(P2MinON.Text) div 256;
                  Data[89] := StrToInt(P2MinON.Text) - Data[90]*256;
                  Data[94] := StrToInt(P2MaxON.Text) div 256;
                  Data[93] := StrToInt(P2MaxON.Text) - Data[94]*256;
                  Data[98] := StrToInt(P2MinOFF.Text) div 256;
                  Data[97] := StrToInt(P2MinOFF.Text) - Data[98]*256;
                  Data[102] := StrToInt(P2MaxOFF.Text) div 256;
                  Data[101] := StrToInt(P2MaxOFF.Text) - Data[102]*256;

                  Data[106] := StrToInt(CyclesEdit.Text) div 256;
                  Data[105] := StrToInt(CyclesEdit.Text) - Data[106]*256;
                end;
             3: begin
                  Data[110] := StrToInt(P1MinON.Text) div 256;
                  Data[109] := StrToInt(P1MinON.Text) - Data[110]*256;
                  Data[114] := StrToInt(P1MaxON.Text) div 256;
                  Data[113] := StrToInt(P1MaxON.Text) - Data[114]*256;
                  Data[118] := StrToInt(P1MinOFF.Text) div 256;
                  Data[117] := StrToInt(P1MinOFF.Text) - Data[118]*256;
                  Data[122] := StrToInt(P1MaxOFF.Text) div 256;
                  Data[121] := StrToInt(P1MaxOFF.Text) - Data[122]*256;

                  Data[126] := StrToInt(P2MinON.Text) div 256;
                  Data[125] := StrToInt(P2MinON.Text) - Data[126]*256;
                  Data[130] := StrToInt(P2MaxON.Text) div 256;
                  Data[129] := StrToInt(P2MaxON.Text) - Data[130]*256;
                  Data[134] := StrToInt(P2MinOFF.Text) div 256;
                  Data[133] := StrToInt(P2MinOFF.Text) - Data[134]*256;
                  Data[138] := StrToInt(P2MaxOFF.Text) div 256;
                  Data[137] := StrToInt(P2MaxOFF.Text) - Data[138]*256;

                  Data[142] := StrToInt(CyclesEdit.Text) div 256;
                  Data[141] := StrToInt(CyclesEdit.Text) - Data[142]*256;
                end;
           end;
           //If Sender = SaveBut then
           Reg.WriteBinaryData(CadenceKey, Data[0], sz);
         Except
           MessageDlg('Problems with saving Signals Cadence!', mtError, [mbOK], 0);
         End;
       end;
    4: begin // Save Timing
         Try
           Reg.OpenKey(ModemKey + PNP_Key + CountryWord + Country_Key, False);
           sz := Reg.GetDataSize(TimingKey);
           SetLength(Data, sz);
           Reg.ReadBinaryData(TimingKey, Data[0], sz);
           Data[1] := StrToInt(Delay1Edit.Text) div 256;
           Data[0] := StrToInt(Delay1Edit.Text) - Data[1]*256;
           Data[3] := StrToInt(Delay2Edit.Text) div 256;
           Data[2] := StrToInt(Delay2Edit.Text) - Data[3]*256;
           Data[5] := StrToInt(Delay3Edit.Text) div 256;
           Data[4] := StrToInt(Delay3Edit.Text) - Data[5]*256;
           Data[7] := StrToInt(Delay4Edit.Text) div 256;
           Data[6] := StrToInt(Delay4Edit.Text) - Data[7]*256;
           Reg.WriteBinaryData(TimingKey, Data[0], sz);

           sz := Reg.GetDataSize(ToneKey);
           SetLength(Data, sz);
           Reg.ReadBinaryData(ToneKey, Data[0], sz);
           Data[1] := StrToInt(Detect1Edit.Text) div 256;
           Data[0] := StrToInt(Detect1Edit.Text) - Data[1]*256;
           Data[3] := StrToInt(Detect2Edit.Text) div 256;
           Data[2] := StrToInt(Detect2Edit.Text) - Data[3]*256;
           Reg.WriteBinaryData(ToneKey, Data[0], sz);
         Except
           MessageDlg('Problems with saving Timing parameters!', mtError, [mbOK], 0);
         End;
       end;
    5: begin // Save Statistics
         SaveDialog.Filter := 'Text files (*.txt)|*.TXT|Log files (*.log)|*.LOG|NotePad files (*.not)|*.NOT|All files (*.*)|*.*';
         If SaveDialog.Execute then
         Try
           FilePath := SaveDialog.FileName;
           AssignFile(TF, FilePath);
           Rewrite(TF);
           WriteLn(TF, 'STATISTICS OF LAST CONNECTION');
           WriteLn(TF, '');
           For I := 0 to MemoStat.Lines.Count do
           begin
             WriteLn(TF, MemoStat.Lines[I]);
           end;
           WriteLn(TF, '');
           CloseFile(TF);
         Except
           ShowMessage('Can''t save info!');
         End;
       end;
  end;
}
  Reg.CloseKey;
  Reg.Free;
end;

procedure THCFForm.ResetTabs(Sender: TObject);
begin
  if (AboutPanel.Visible and CanHideSplash) then
  begin
    SaveBut.Enabled := True;
    AboutPanel.Visible := False;
    Pages.Visible := True;
  end;
  if CanHideSplash then
  begin
    if Pages.ActivePage.Name = 'TabInfo' then
    begin
      HCFForm.ReadInfo(Sender);
      File_Save.Enabled := false;
      File_Savetofile.Enabled := true;
    end;
    if Pages.ActivePage.Name = 'TabInits' then
    begin
      HCFForm.ReadInits(Sender);
      File_Save.Enabled := false;
      File_Savetofile.Enabled := true;
    end;
    if Pages.ActivePage.Name = 'TabTransmit' then
    begin
      HCFForm.TXUpdate(Sender);
      File_Save.Enabled := true;
      File_Savetofile.Enabled := false;
    end;
    if Pages.ActivePage.Name = 'TabRegisters' then
    begin
      HCFForm.RegistersUpdate(Sender);
      File_Save.Enabled := false;
      File_Savetofile.Enabled := true;
    end;
    if Pages.ActivePage.Name = 'TabSignals' then
    begin
      SignalsBox.ItemIndex := 0;
      HCFForm.SignUpdate(Sender);
      File_Save.Enabled := true;
      File_Savetofile.Enabled := false;
    end;
    if Pages.ActivePage.Name = 'TabTiming' then
    begin
      HCFForm.ReadTiming(Sender);
      File_Save.Enabled := true;
      File_Savetofile.Enabled := false;
    end;
    if Pages.ActivePage.Name = 'TabBlacklist' then
    begin
      File_Save.Enabled := false;
      File_Savetofile.Enabled := false;
    end;
    if Pages.ActivePage.Name = 'TabMonitoring' then
    begin
      File_Save.Enabled := false;
      File_Savetofile.Enabled := false;
    end;
    if Pages.ActivePage.Name = 'TabStatistics' then
    begin
      HCFForm.ReadStat(Sender);
      File_Save.Enabled := false;
      File_Savetofile.Enabled := true;
    end;
  end;  
end;

procedure THCFForm.RegistersUpdate(Sender: TObject);
var
  Data : Array of Byte;
  sz : Word;
  I, J, GridLines, Pos : Integer;
begin
  Reg := TRegistry.Create;
  Reg.RootKey := HKEY_LOCAL_MACHINE;

  // read values of all S-registers
  if Reg.OpenKeyReadOnly(ModemKey + PNP_Key) and Reg.ValueExists(SregZName) then
  try
    sz := Reg.GetDataSize(SregZName);
    SetLength(Data, sz);
    Reg.ReadBinaryData(SregZName, Data[0], sz);
    SRegGrid.RowCount := sz+1;
    RegistersGridRows := sz-1;

    SRegGrid.FixedCols := 1;
    SRegGrid.FixedRows := 1;
    SRegGrid.GridLineWidth := 1;
    SRegGrid.Enabled := true;

    SRegGrid.Cells[0, 0]:= 'SREG';
    SRegGrid.Cells[1, 0]:= 'Current';
    SRegGrid.Cells[2, 0]:= 'Stored';

    for I := 0 to sz do
    begin
      SRegGrid.Cells[0, I+1]:= 'S'+IntToStr(I);
      //StringGrid1.Cells[1, I+1]:= IntToStr(Data[I]);
      SRegGrid.Cells[2, I+1]:= IntToStr(Data[I]);
    end;
    Reg.ReadBinaryData(SregCName, Data[0], sz);
    for I := 0 to sz do SRegGrid.Cells[1, I+1]:= IntToStr(Data[I]);
  finally
    Reg.CloseKey;
  end
  else
  begin
    SRegGrid.FixedCols := 0;
    SRegGrid.FixedRows := 0;
    SRegGrid.GridLineWidth := 0;
    for I := 0 to SRegGrid.RowCount do for J := 0 to 2 do SRegGrid.Cells[J, I] := '';
    SRegGrid.Enabled := false;
    SRegGrid.Cells[1, 1] := 'Read';
    SRegGrid.Cells[2, 1] := 'Error';
  end;

  // read S-registers limit & default values
  if Reg.OpenKeyReadOnly(ModemKey + PNP_Key + CountryWord + Country_Key) and Reg.ValueExists(SregLimName) then
  try
    sz := Reg.GetDataSize(SregLimName);
    SetLength(Data, sz);
    Reg.ReadBinaryData(SregLimName, Data[0], sz);
    GridLines := sz div 4;
    LimitGridRows := GridLines;
    SregLimGrid.RowCount := GridLines + 1;

    SregLimGrid.FixedCols := 1;
    SregLimGrid.FixedRows := 1;
    SregLimGrid.GridLineWidth := 1;
    SregLimGrid.Enabled := true;


    SregLimGrid.Cells[0, 0]:= 'SREG';
    SregLimGrid.Cells[1, 0]:= 'Min';
    SregLimGrid.Cells[2, 0]:= 'Max';
    SregLimGrid.Cells[3, 0]:= 'Default';

    for I := 0 to GridLines do
    begin
      Pos := I*4;
      SregLimGrid.Cells[0, I+1]:= 'S'+IntToStr(Data[Pos]);
      SregLimGrid.Cells[1, I+1]:= IntToStr(Data[Pos+1]);
      SregLimGrid.Cells[2, I+1]:= IntToStr(Data[Pos+2]);
      SregLimGrid.Cells[3, I+1]:= IntToStr(Data[Pos+3]);
      //StringGrid1.Cells[1, I+1]:= IntToStr(Data[I]);
      //SregLimGrid.Cells[2, I+1]:= IntToStr(Data[I]);
    end;
    //Reg.ReadBinaryData(SregCName, Data[0], sz);
    //For I := 0 to sz do SregLimGrid.Cells[1, I+1]:= IntToStr(Data[I]);

  finally
    Reg.CloseKey;
  end
  else
  begin
    SregLimGrid.FixedCols := 0;
    SregLimGrid.FixedRows := 0;
    SregLimGrid.GridLineWidth := 0;
    for I := 0 to SregLimGrid.RowCount do for J := 0 to 3 do SregLimGrid.Cells[J, I] := '';
    SregLimGrid.Enabled := false;
    SregLimGrid.Cells[1, 1] := 'Data';
    SregLimGrid.Cells[2, 1] := 'Read';
    SregLimGrid.Cells[3, 1] := 'Error';
  end;
  Reg.Free;
end;

procedure THCFForm.TXUpdate(Sender: TObject);
var
  Data : Array of Byte;
  sz : Word;
  az: byte;

begin
  Reg := TRegistry.Create;
  Reg.RootKey := HKEY_LOCAL_MACHINE;
  try
    if not Reg.OpenKeyReadOnly(ModemKey + PNP_Key + CountryWord + Country_Key) then raise ERangeError.CreateFmt('', []);
    if ((Sender <> ProtocolBox) and (Sender <> LineQualityBox)) then
    begin
      sz := Reg.GetDataSize(CntrTX);
      SetLength(Data, sz);
      Reg.ReadBinaryData(CntrTX, Data[0], sz);
      DataTXBox.ItemIndex:=Data[2];
      FaxTXBox.ItemIndex:=Data[5];
      VoiceTXBox.ItemIndex:=Data[8];
      //LowTXEdit.Text := '-' + FloatToStr(Data[10] div 10);
      //HighTXEdit.Text := '-' + FloatToStr(Data[11] div 10);
      //HCFFormModProtocolBoxChange(Sender);
  Reg.OpenKeyReadOnly(ModemKey + PNP_Key + OEMKey);
  SetLength(Data, 24);
  Reg.ReadBinaryData('AT+MS', Data[0], 24);
  if Data[4] = 0 then ModNegCheckBox.Checked := false else ModNegCheckBox.Checked := true;
           ModTXMinBox.Clear;
           ModTXMaxBox.Clear;
           ModRXMinBox.Clear;
           ModRXMaxBox.Clear;
  case Data[0] of
    $00: ModProtocolBox.ItemIndex := 5;
    $01: ModProtocolBox.ItemIndex := 4;

    $20: ModProtocolBox.ItemIndex := 3;
    $22: begin
           ModProtocolBox.ItemIndex := 2;
           ModTXMinBox.Items.CommaText := '33600 31200 28800 26400 24000 21600 19200 16800 14400 12000 9600 7200 4800 2400';
           ModTXMaxBox.Items.CommaText := '33600 31200 28800 26400 24000 21600 19200 16800 14400 12000 9600 7200 4800 2400';
           ModRXMinBox.Items.CommaText := '33600 31200 28800 26400 24000 21600 19200 16800 14400 12000 9600 7200 4800 2400';
           ModRXMaxBox.Items.CommaText := '33600 31200 28800 26400 24000 21600 19200 16800 14400 12000 9600 7200 4800 2400';
         end;
    $38: begin
           ModProtocolBox.ItemIndex := 1;
           ModTXMinBox.Items.CommaText := '56000 54000 52000 50000 48000 46000 44000 42000 40000 38000 36000 34000 32000';
           ModTXMaxBox.Items.CommaText := '56000 54000 52000 50000 48000 46000 44000 42000 40000 38000 36000 34000 32000';
           ModRXMinBox.Items.CommaText := '56000 54000 52000 50000 48000 46000 44000 42000 40000 38000 36000 34000 32000';
           ModRXMaxBox.Items.CommaText := '56000 54000 52000 50000 48000 46000 44000 42000 40000 38000 36000 34000 32000';
         end;
    $5A: begin
           ModProtocolBox.ItemIndex := 0;
           ModTXMinBox.Items.CommaText := '56000 54667 53333 52000 50667 49333 48000 46667 45333 42667 41333 40000 38667 37333 36000 34667 33333 32000 30667 29333 28000';
           ModTXMaxBox.Items.CommaText := '56000 54667 53333 52000 50667 49333 48000 46667 45333 42667 41333 40000 38667 37333 36000 34667 33333 32000 30667 29333 28000';
           ModRXMinBox.Items.CommaText := '56000 54667 53333 52000 50667 49333 48000 46667 45333 42667 41333 40000 38667 37333 36000 34667 33333 32000 30667 29333 28000';
           ModRXMaxBox.Items.CommaText := '56000 54667 53333 52000 50667 49333 48000 46667 45333 42667 41333 40000 38667 37333 36000 34667 33333 32000 30667 29333 28000';
         end;
  end;
  Reg.CloseKey;



      Reg.OpenKeyReadOnly(ModemKey + PNP_Key + CountryWord + Country_Key);
      ProtocolBox.ItemIndex := 0;
      Reg.ReadBinaryData(CntrSpeed, SpeedAdj[0], 3);
    end;

    //    -  -  
    if (Sender = LineQualityBox) then
    begin
      case LineQualityBox.ItemIndex of
        0: begin
             CustomMaskL.Text := '15';
             CustomMaskR.Text := '00';
           end;
        1: begin
             CustomMaskL.Text := '03';
             CustomMaskR.Text := '00';
           end;
        2: begin
             CustomMaskL.Text := '10';
             CustomMaskR.Text := '01';
           end;
        3: begin
             CustomMaskL.Text := '06';
             CustomMaskR.Text := '03';
           end;
        4: begin
             CustomMaskL.Text := '15';
             CustomMaskR.Text := '05';
           end;
      end;
      SpeedAdj[ProtocolBox.ItemIndex] := StrToInt(CustomMaskL.Text) * $10 + StrToInt(CustomMaskR.Text);
    end
    else
    begin
      az := SpeedAdj[ProtocolBox.ItemIndex] div $10;
      CustomMaskR.Text := IntToStr(SpeedAdj[ProtocolBox.ItemIndex] - (SpeedAdj[ProtocolBox.ItemIndex] div $10) * $10);
      CustomMaskL.Text := IntToStr(az);
//      CustomMaskL.Text := IntToStr(SpeedAdj[ProtocolBox.ItemIndex] div $10);
//      ShowMessage(IntToStr(SpeedAdj[ProtocolBox.ItemIndex] - (SpeedAdj[ProtocolBox.ItemIndex] div $10) * $10));
    end;

    CalculateAggressiveness(Sender);
    AggressivenessChange(Sender);
    Reg.CloseKey;

    // enable components
    DataTXBox.Enabled := true;
    FaxTXBox.Enabled := true;
    VoiceTXBox.Enabled := true;
    DataTXLabel.Enabled := true;
    FaxTXLabel.Enabled := true;
    VoiceTXLabel.Enabled := true;
    ProtocolBox.Enabled := true;
    AggressivenessSpeedLabel.Enabled := true;
    AggressivenessRadioBtn1.Enabled := true;
    AggressivenessRadioBtn2.Enabled := true;

    //LowTXLabel.Enabled := true;
    //HighTXLabel.Enabled := true;
    //LowTXEdit.Enabled := true;
    //HighTXEdit.Enabled := true;
    //LowdBmLabel.Enabled := true;
    //HighdBmLabel.Enabled := true;

  except
    DataTXBox.Enabled := false;
    FaxTXBox.Enabled := false;
    VoiceTXBox.Enabled := false;
    DataTXLabel.Enabled := false;
    FaxTXLabel.Enabled := false;
    VoiceTXLabel.Enabled := false;
    ProtocolBox.Enabled := false;
    LineQualityBox.Enabled := false;
    AggressivenessSpeedLabel.Enabled := false;
    AggressivenessRadioBtn1.Enabled := false;
    AggressivenessRadioBtn2.Enabled := false;
    CustomMaskL.Enabled := false;
    CustomMaskR.Enabled := false;
    PerCentLabel.Enabled := false;
    TenLabel.Enabled := false;
    BLERLabel.Enabled := false;
    BLERLabel.Caption := 'Read Error';
    //LowTXLabel.Enabled := false;
    //HighTXLabel.Enabled := false;
    //LowTXEdit.Enabled := false;
    //HighTXEdit.Enabled := false;
    //LowdBmLabel.Enabled := false;
    //HighdBmLabel.Enabled := false;
  end;
    Reg.Free;
end;

procedure THCFForm.About(Sender: TObject);
begin
  SaveBut.Enabled := False;
  File_Save.Enabled := False;
  File_Savetofile.Enabled := False;
  Pages.Visible := False;
  AboutPanel.Visible := True;
end;

procedure THCFForm.NotReady(Sender: TObject);
begin
  ShowMessage('Sorry, yet not ready!'+#13#10+'Latest updates can be found at'
+#13#10+'http://hcfconf.cjb.net');
end;

procedure THCFForm.COMChange(Sender: TObject);
begin
  COM11.Checked:=false;
  COM21.Checked:=false;
  COM31.Checked:=false;
  COM41.Checked:=false;
  COM51.Checked:=false;
  COM61.Checked:=false;
  If Sender = COM11 then
  begin
    COM11.Checked:=true;
    ComPort := 'COM1';
  end;
  If Sender = COM21 then
  begin
    COM21.Checked:=true;
    ComPort := 'COM2';
  end;
  If Sender = COM31 then
  begin
    COM31.Checked:=true;
    ComPort := 'COM3';
  end;
  If Sender = COM41 then
  begin
    COM41.Checked:=true;
    ComPort := 'COM4';
  end;
  If Sender = COM51 then
  begin
    COM51.Checked:=true;
    ComPort := 'COM5';
  end;
  If Sender = COM61 then
  begin
    COM61.Checked:=true;
    ComPort := 'COM6';
  end;
end;

procedure THCFForm.ReadStat(Sender: TObject);
begin
  Event := TEvent.Create(nil, True, False, '');
  ComPort1.Events := [];
  Try
    Try
      ComPort1.Port := ComPort;
      ComPort1.Open;
    Except
      MessageDlg('Can''t open port '+ComPort+'!', mtError, [mbOK], 0);
      //Exit(sender);
    end;
    ComPort1.Events := [evRxChar];
    ComPort1.WriteStr('AT#UD'+#13#10);
    ComPort1.WaitForEvent(Events, Event.Handle, 300);
    MemoStat.Clear;
    ComPort1.ReadStr(Stat, ComPort1.InputCount);
    MemoStat.Lines[0] := Stat;
    ComPort1.Close;
    DeCodeStat(Sender);
  Except
    MessageDlg('Port is busy!', mtError, [mbOK], 0);
  End;
end;

procedure THCFForm.DeCodeStat(Sender: TObject);
var
  UD_stat: TStringList;
  I, Index: Byte;
  Buf, KeyS, ValueS: String;
  _Key, _Value: Integer;

begin
  UD_stat := TStringList.Create;
  UD_stat.Clear;

  For I := 0 to MemoStat.Lines.Count do
  begin
//    UD_stat[I] := MemoStat.Lines.Strings[I];
    UD_stat.Add(MemoStat.Lines.Strings[I]);
  end;
  MemoStat.Lines.Clear;

//  UD_stat[1] := Stat;
  For I := 1 to (UD_stat.Count - 1) do
//  For I := 1 to MemoStat.Lines.Count do
  begin
    Buf := UD_stat.Strings[I];
//    Buf := MemoStat.Lines.Strings[I];
    Index := 15;
    If Buf <> '' then
    begin
      If Copy(Buf, 1, 14) = 'DIAG <2A4D3263' then
      begin
        While Buf[Index] <> '>' do
        begin
          If Buf[Index] = ' ' then
          begin
            Inc(Index);
            While Buf[Index] <> '=' do
            begin
              KeyS := KeyS + Buf[Index];
              Inc(Index);
            end;
          end;
          If Buf[Index] = '=' then
          begin
            Inc(Index);
            While (Buf[Index] <> ' ') and (Buf[Index] <> '>') do
            begin
              If Buf[Index] = '"' then
              begin
                ValueS := 'N/A';
                Inc(Index);
                Inc(Index);
                Break;
              end;
              ValueS := ValueS + Buf[Index];
              Inc(Index);
            end;
          end;
          _Key := StrToInt('$'+KeyS);
          If ValueS <> 'N/A' then _Value := StrToInt('$'+ValueS);
          Case _Key of
            $0: begin
                  Case _Value of
                    $01: MemoStat.Lines.Add('Diagnostic revision ....... 0.1 (2 Dec 1996)');
                    $02: MemoStat.Lines.Add('Diagnostic revision ....... 0.2 (22 Jan 1997)');
                    $03: MemoStat.Lines.Add('Diagnostic revision ....... 0.3 (27 Jan 1997)');
                    $04: MemoStat.Lines.Add('Diagnostic revision ....... 0.4 (3 March 1997)');
                    $05: MemoStat.Lines.Add('Diagnostic revision ....... 0.5 (4 March 1997)');
                    $06: MemoStat.Lines.Add('Diagnostic revision ....... 0.6 (21 March 1997)');
                    $07: MemoStat.Lines.Add('Diagnostic revision ....... 0.7 (1 May 1997)');
                    $08: MemoStat.Lines.Add('Diagnostic revision ....... 0.8 (13 June 1997)');
                    $09: MemoStat.Lines.Add('Diagnostic revision ....... 0.9 (11 June 1998)');
                    $10: MemoStat.Lines.Add('Diagnostic revision ....... 1.0 (2 July 1998)')
                  else MemoStat.Lines.Add('Diagnostic revision ....... Unknown Version')
                  end;
                end;
            $1: begin
                  Case _Value of
                    0: MemoStat.Lines.Add('Call Setup Result ......... No Previous Call');
                    1: MemoStat.Lines.Add('Call Setup Result ......... No Dialtone');
                    2: MemoStat.Lines.Add('Call Setup Result ......... Reorder Signal');
                    3: MemoStat.Lines.Add('Call Setup Result ......... Busy Signal');
                    4: MemoStat.Lines.Add('Call Setup Result ......... No Recognized');
                    5: MemoStat.Lines.Add('Call Setup Result ......... Voice Detected');
                    6: MemoStat.Lines.Add('Call Setup Result ......... Text Telephone');
                    7: MemoStat.Lines.Add('Call Setup Result ......... Data Answering');
                    8: MemoStat.Lines.Add('Call Setup Result ......... Data Calling');
                    9: MemoStat.Lines.Add('Call Setup Result ......... Fax Answering');
                   10: MemoStat.Lines.Add('Call Setup Result ......... Fax Calling');
                   11: MemoStat.Lines.Add('Call Setup Result ......... V.8bis Signal');
                  end;
                end;
            $2: begin
                  Case _Value of
                    0: MemoStat.Lines.Add('Multimedia mode ........... Data Only');
                    1: MemoStat.Lines.Add('Multimedia mode ........... FAX Only');
                    2: MemoStat.Lines.Add('Multimedia mode ........... Voice Only');
                    3: MemoStat.Lines.Add('Multimedia mode ........... VoiceViewT');
                    4: MemoStat.Lines.Add('Multimedia mode ........... ASVD, V.61');
                    5: MemoStat.Lines.Add('Multimedia mode ........... ASVD, V.34Q');
                    6: MemoStat.Lines.Add('Multimedia mode ........... DSVD, Multi-Tech');
                    7: MemoStat.Lines.Add('Multimedia mode ........... DSVD, 1.2');
                    8: MemoStat.Lines.Add('Multimedia mode ........... DSVD, V.70');
                    9: MemoStat.Lines.Add('Multimedia mode ........... Video-Telephony');
                   10: MemoStat.Lines.Add('Multimedia mode ........... Other V.80 Call');
                  end;
                end;
            $3: begin
                  Case _Value of
                    0: MemoStat.Lines.Add('DTE-DCE mode .............. Async Data');
                    1: MemoStat.Lines.Add('DTE-DCE mode .............. Transparent V.80');
                    2: MemoStat.Lines.Add('DTE-DCE mode .............. Framed V.80');
                  end;
                end;
            $4: MemoStat.Lines.Add('V.8 CM octet string ....... ' + ValueS + ' quotes');
            $5: MemoStat.Lines.Add('V.8 JM octet string ....... ' + ValueS + ' quotes');
            $6..$F: MemoStat.Lines.Add('Reserved .................. ' + ValueS);
            $10: MemoStat.Lines.Add('Received signal ........... -' + IntToStr(_Value) + ' dBm');
            $11: MemoStat.Lines.Add('Transmit signal ........... -' + IntToStr(_Value) + ' dBm');
            $12: MemoStat.Lines.Add('Noise level ............... -' + IntToStr(_Value) + ' dBm');
            $13: MemoStat.Lines.Add('Reserved .................. ' + ValueS);  //
            $14: MemoStat.Lines.Add('Near echo loss ........ ' + ValueS + ' dB');
            $15: MemoStat.Lines.Add('Far echo loss ......... ' + ValueS + ' dB');
            $16: MemoStat.Lines.Add('Far echo delay ........ ' + ValueS + ' ms');
            $17: MemoStat.Lines.Add('Round Trip delay ...... ' + ValueS + ' ms');
//
//            $18: begin
//                   Case _Value of
//                     0: MemoStat.Lines.Add('V.34 INFO bit map ......... ');
//                   end;
//                 end;
//
            $19..$1F: MemoStat.Lines.Add('Reserved .................. ' + ValueS);
            $20: begin
                   Case _Value of
                     0: MemoStat.Lines.Add('Transmit Negotiation ...... V.17');
                     1: MemoStat.Lines.Add('Transmit Negotiation ...... V.21');
                     2: MemoStat.Lines.Add('Transmit Negotiation ...... V.22');
                     3: MemoStat.Lines.Add('Transmit Negotiation ...... V.22bis');
                     4: MemoStat.Lines.Add('Transmit Negotiation ...... V.23');
                     5: MemoStat.Lines.Add('Transmit Negotiation ...... V.23 (half duplex)');
                     6: MemoStat.Lines.Add('Transmit Negotiation ...... V.26bis');
                     7: MemoStat.Lines.Add('Transmit Negotiation ...... V.26ter');
                     8: MemoStat.Lines.Add('Transmit Negotiation ...... V.27ter');
                     9: MemoStat.Lines.Add('Transmit Negotiation ...... V.29 (half duplex)');
                    $A: MemoStat.Lines.Add('Transmit Negotiation ...... V.32');
                    $B: MemoStat.Lines.Add('Transmit Negotiation ...... V.32bis');
                    $C: MemoStat.Lines.Add('Transmit Negotiation ...... V.34');
                    $D: MemoStat.Lines.Add('Transmit Negotiation ...... V.34 (half duplex)');
                    $E: MemoStat.Lines.Add('Transmit Negotiation ...... V.90 (asym)');
                    $F: MemoStat.Lines.Add('Transmit Negotiation ...... V.90 (sym)');
                    $10..$7F: MemoStat.Lines.Add('Transmit Negotiation ...... V.58');
                    $80: MemoStat.Lines.Add('Transmit Negotiation ...... X2');
                    $81: MemoStat.Lines.Add('Transmit Negotiation ...... K56FLEX');
                    $82: MemoStat.Lines.Add('Transmit Negotiation ...... V.FC');
                    $83: MemoStat.Lines.Add('Transmit Negotiation ...... V.32terbo');
                    $84: MemoStat.Lines.Add('Transmit Negotiation ...... Bell 212A');
                    $85: MemoStat.Lines.Add('Transmit Negotiation ...... Bell 103');
                    $86..$FF: MemoStat.Lines.Add('Transmit Negotiation ...... Unknown');
                   end;
                 end;
            $21: begin
                   Case _Value of
                     0: MemoStat.Lines.Add('Receive Negotiation ....... V.17');
                     1: MemoStat.Lines.Add('Receive Negotiation ....... V.21');
                     2: MemoStat.Lines.Add('Receive Negotiation ....... V.22');
                     3: MemoStat.Lines.Add('Receive Negotiation ....... V.22bis');
                     4: MemoStat.Lines.Add('Receive Negotiation ....... V.23');
                     5: MemoStat.Lines.Add('Receive Negotiation ....... V.23 (half duplex)');
                     6: MemoStat.Lines.Add('Receive Negotiation ....... V.26bis');
                     7: MemoStat.Lines.Add('Receive Negotiation ....... V.26ter');
                     8: MemoStat.Lines.Add('Receive Negotiation ....... V.27ter');
                     9: MemoStat.Lines.Add('Receive Negotiation ....... V.29 (half duplex)');
                    $A: MemoStat.Lines.Add('Receive Negotiation ....... V.32');
                    $B: MemoStat.Lines.Add('Receive Negotiation ....... V.32bis');
                    $C: MemoStat.Lines.Add('Receive Negotiation ....... V.34');
                    $D: MemoStat.Lines.Add('Receive Negotiation ....... V.34 (half duplex)');
                    $E: MemoStat.Lines.Add('Receive Negotiation ....... V.90 (asym)');
                    $F: MemoStat.Lines.Add('Receive Negotiation ....... V.90 (sym)');
                    $10..$7F: MemoStat.Lines.Add('Receive Negotiation ....... V.58');
                    $80: MemoStat.Lines.Add('Receive Negotiation ....... X2');
                    $81: MemoStat.Lines.Add('Receive Negotiation ....... K56FLEX');
                    $82: MemoStat.Lines.Add('Receive Negotiation ....... V.FC');
                    $83: MemoStat.Lines.Add('Receive Negotiation ....... V.32terbo');
                    $84: MemoStat.Lines.Add('Receive Negotiation ....... Bell 212A');
                    $85: MemoStat.Lines.Add('Receive Negotiation ....... Bell 103');
                    $86..$FF: MemoStat.Lines.Add('Receive Negotiation ....... Unknown');
                   end;
                 end;
            $22: MemoStat.Lines.Add('Transmit Carrier rate ..... ' + IntToStr(_Value) + ' symbol/s');
            $23: MemoStat.Lines.Add('Receive Carrier rate ...... ' + IntToStr(_Value) + ' symbol/s');
            $24: MemoStat.Lines.Add('Transmit Carrier freq ..... ' + IntToStr(_Value) + ' Hz');
            $25: MemoStat.Lines.Add('Receive Carrier freq ...... ' + IntToStr(_Value) + ' Hz');
            $26: MemoStat.Lines.Add('First transmit rate ....... ' + IntToStr(_Value) + ' bit/s');
            $27: MemoStat.Lines.Add('First receive rate ........ ' + IntToStr(_Value) + ' bit/s');
            $28..$2F: MemoStat.Lines.Add('Reserved .................. ' + ValueS);
            $30: MemoStat.Lines.Add('Carrier loss count ........ ' + IntToStr(_Value));
            $31: MemoStat.Lines.Add('Re-negotiation count ...... ' + IntToStr(_Value));
            $32: MemoStat.Lines.Add('Retrains requested ........ ' + IntToStr(_Value));
            $33: MemoStat.Lines.Add('Retrains detected ......... ' + IntToStr(_Value));
            $34: MemoStat.Lines.Add('Final transmit rate ....... ' + IntToStr(_Value)+' bit/s');
            $35: MemoStat.Lines.Add('Final receive rate ........ ' + IntToStr(_Value)+' bit/s');
            $36..$3F: MemoStat.Lines.Add('Reserved .................. ' + ValueS);
            $40: begin
                   Case _Value of
                     0: MemoStat.Lines.Add('Protocol Negotiation ...... None');
                     1: MemoStat.Lines.Add('Protocol Negotiation ...... V.42 LAPM');
                     2: MemoStat.Lines.Add('Protocol Negotiation ...... MNPT');
                     3..$7F: MemoStat.Lines.Add('Protocol Negotiation ...... Unknown');
                     $80: MemoStat.Lines.Add('Protocol Negotiation ...... MNP10T');
                     $81: MemoStat.Lines.Add('Protocol Negotiation ...... ECPT');
                     $82: MemoStat.Lines.Add('Protocol Negotiation ...... ETCT');
                     $83-$FF: MemoStat.Lines.Add('Protocol Negotiation ...... Unknown');
                   end;
                 end;
            $41: MemoStat.Lines.Add('Frame size ................ ' + IntToStr(_Value)+' bytes');
            $42: MemoStat.Lines.Add('Link timeouts ............. ' + IntToStr(_Value));
            $43: MemoStat.Lines.Add('Link NAKs received ........ ' + IntToStr(_Value));
            $44: begin
                   Case _Value of
                     0: MemoStat.Lines.Add('Compression Negotiation ... None');
                     1: MemoStat.Lines.Add('Compression Negotiation ... V.42bis');
                     2..$7F: MemoStat.Lines.Add('Compression Negotiation ... V.58');
                     $80: MemoStat.Lines.Add('Compression Negotiation ... MNP5T');
                     $81-$FF: MemoStat.Lines.Add('Compression Negotiation ... Unknown');
                   end;
                 end;
            $45: MemoStat.Lines.Add('Compression Dictionary .... ' + IntToStr(_Value)+' bytes');
            $46..$4F: MemoStat.Lines.Add('Reserved .................. ' + ValueS);
            $52: MemoStat.Lines.Add('Transmit sent from DTE .... ' + IntToStr(_Value)+' characters');
            $53: MemoStat.Lines.Add('Received sent to DTE ...... ' + IntToStr(_Value)+' characters');
            $54: MemoStat.Lines.Add('Transmit data lost ........ ' + IntToStr(_Value)+' characters');
            $55: MemoStat.Lines.Add('Received data lost ........ ' + IntToStr(_Value)+' characters');
            $56: MemoStat.Lines.Add('Transmit I-Frame count .... ' + IntToStr(_Value));
            $57: MemoStat.Lines.Add('Received I-Frame count .... ' + IntToStr(_Value));
            $58: MemoStat.Lines.Add('Transmit I-Frame errors ... ' + IntToStr(_Value));
            $59: MemoStat.Lines.Add('Received I-Frame errors ... ' + IntToStr(_Value));
            $5A..$5F: MemoStat.Lines.Add('Reserved .................. ' + ValueS);

            $60: begin
                   Case _Value of
                     $0: MemoStat.Lines.Add('Termination Reason ........ Unidentified');
                     $1: MemoStat.Lines.Add('Termination Reason ........ No Previous Call');
                     $2: MemoStat.Lines.Add('Termination Reason ........ Call Is Still In Progress');
                     $3: MemoStat.Lines.Add('Termination Reason ........ Call Waiting Signal Detected');
                     $4: MemoStat.Lines.Add('Termination Reason ........ Call Attempts Limit Exceeded');
                     $A: MemoStat.Lines.Add('Termination Reason ........ Initiated Dial Call');
                     $B: MemoStat.Lines.Add('Termination Reason ........ Initiated Leased Line Restoral');
                     $C: MemoStat.Lines.Add('Termination Reason ........ Initiated Redial');
                     $D: MemoStat.Lines.Add('Termination Reason ........ Initiated Dial Disconnect');
                     $14: MemoStat.Lines.Add('Termination Reason ........ Power Loss DCE');
                     $15: MemoStat.Lines.Add('Termination Reason ........ Equipment Failure');
                     $16: MemoStat.Lines.Add('Termination Reason ........ Front Panel Disconnect Requested');
                     $17: MemoStat.Lines.Add('Termination Reason ........ Front Panel Leased Line Restoral');
                     $18: MemoStat.Lines.Add('Termination Reason ........ Automatic Leased Line Restoral');
                     $19: MemoStat.Lines.Add('Termination Reason ........ Inactivity Timer Expired');
                     $1E: MemoStat.Lines.Add('Termination Reason ........ Inactivity Timer Expired');
                     $1F: MemoStat.Lines.Add('Termination Reason ........ Inactivity Timer Expired');
//1E cct116RestoralRequest DTE Interface
//1F cct108isOffInhibitsDial
                     $20: MemoStat.Lines.Add('Termination Reason ........ Turned Off');
                     $28: MemoStat.Lines.Add('Termination Reason ........ No Number Provided');
                     $29: MemoStat.Lines.Add('Termination Reason ........ Blacklisted Number');
                     $2A: MemoStat.Lines.Add('Termination Reason ........ Call Attempts Limit Exceeded');
                     $2B: MemoStat.Lines.Add('Termination Reason ........ Extension Phone Off Hook');
                     $2C: MemoStat.Lines.Add('Termination Reason ........ Call Setup Fail Timer Expired');
                     $2D: MemoStat.Lines.Add('Termination Reason ........ Incoming Call Detected');
                     $2E: MemoStat.Lines.Add('Termination Reason ........ Loop Current Interrupted');
                     $2F: MemoStat.Lines.Add('Termination Reason ........ No Dial Tone');
                     $30: MemoStat.Lines.Add('Termination Reason ........ Voice Detected');
                     $31: MemoStat.Lines.Add('Termination Reason ........ Reorder Tone');
                     $32: MemoStat.Lines.Add('Termination Reason ........ Sit Tone');
                     $33: MemoStat.Lines.Add('Termination Reason ........ Engaged Tone');
                     $34: MemoStat.Lines.Add('Termination Reason ........ Long Space Disconnect');
                     $3C: MemoStat.Lines.Add('Termination Reason ........ Carrier Lost Signal Converter');
                     $3D: MemoStat.Lines.Add('Termination Reason ........ Training Failed');
                     $3E: MemoStat.Lines.Add('Termination Reason ........ No Modulation');
                     $3F: MemoStat.Lines.Add('Termination Reason ........ Engaged Tone');
                     $40: MemoStat.Lines.Add('Termination Reason ........ Retrain Attempt Count Exceeded');
                     $41: MemoStat.Lines.Add('Termination Reason ........ Cleardown Received');
                     $42: MemoStat.Lines.Add('Termination Reason ........ Fax Detected');
                     $46: MemoStat.Lines.Add('Termination Reason ........ In Test Mode');
                     $47: MemoStat.Lines.Add('Termination Reason ........ Intrusive Self Test Initiated');
                     $50: MemoStat.Lines.Add('Termination Reason ........ Any Key Abort');
                     $51: MemoStat.Lines.Add('Termination Reason ........ Dte Hangup Command');
                     $52: MemoStat.Lines.Add('Termination Reason ........ Dte Reset Command');
                     $5A: MemoStat.Lines.Add('Termination Reason ........ Frame Reject');
                     $5B: MemoStat.Lines.Add('Termination Reason ........ No Error Control Established');
                     $5C: MemoStat.Lines.Add('Termination Reason ........ Protocol Violation');
                     $5D: MemoStat.Lines.Add('Termination Reason ........ n400exceeded');
                     $5E: MemoStat.Lines.Add('Termination Reason ........ Negotiation Failed');
                     $5F: MemoStat.Lines.Add('Termination Reason ........ Disconnect Frame Received');
                     $60: MemoStat.Lines.Add('Termination Reason ........ Sabme Frame Received');
                     $64: MemoStat.Lines.Add('Termination Reason ........ Loss Of Synchronization');
                   end;
                 end;
            //$62..$7F: MemoStat.Lines.Add('Reserved ' + ValueS);
            //$80..$FF: MemoStat.Lines.Add('Reserved ' + ValueS);
          end;
          KeyS := '';
          ValueS := '';
        end;
      end;
    end;
  end;
end;

procedure THCFForm.SignUpdate(Sender: TObject);
var
  Data : Array of Byte;
  sz : Word;
begin
  Reg := TRegistry.Create;
  Reg.RootKey := HKEY_LOCAL_MACHINE;
  Try
    if not Reg.OpenKeyReadOnly(ModemKey + PNP_Key + CountryWord + Country_Key) then raise ERangeError.CreateFmt('', []);
    If (Sender <> ResetBut) and (Sender <> SigGraph) then ModeBox.ItemIndex := 0;
    Case ModeBox.ItemIndex of
      0: begin
           Reg.OpenKeyReadOnly(ModemKey + PNP_Key + CountryWord + Country_Key);
           If Sender <> SigGraph then
           begin
             SignalsBox.Items.Clear;
             SignalsBox.Items.Add('Dialtone');
             SignalsBox.Items.Add('Busy');
             SignalsBox.Items.Add('Ringback');
             SignalsBox.Items.Add('Congestion');
             SignalsBox.ItemIndex := 0;
           end;
         end;
      1: begin
           Reg.OpenKeyReadOnly(ModemKey + PNP_Key + OEMKey);
           SignalsBox.Items.Clear;
           SignalsBox.Items.Add('Calling Tone');
           SignalsBox.ItemIndex := 0;
         end;
    end;
    sz := Reg.GetDataSize(CadenceKey);
    SetLength(Data, sz);
    Reg.ReadBinaryData(CadenceKey, Data[0], sz);
    If Sender <> SigGraph then
    begin
      PhasesBox.ItemIndex := Data[0]-1;
      PhasesBoxChange(Sender);
    end;
    Case SignalsBox.ItemIndex of
      0: begin
           P1MinON.Text := IntToStr(Data[1]+Data[2]*256);
           P1MaxON.Text := IntToStr(Data[5]+Data[6]*256);
           P1MinOFF.Text := IntToStr(Data[9]+Data[10]*256);
           P1MaxOFF.Text := IntToStr(Data[13]+Data[14]*256);

           P2MinON.Text := IntToStr(Data[17]+Data[18]*256);
           P2MaxON.Text := IntToStr(Data[21]+Data[22]*256);
           P2MinOFF.Text := IntToStr(Data[25]+Data[26]*256);
           P2MaxOFF.Text := IntToStr(Data[29]+Data[30]*256);

           CyclesEdit.Text := IntToStr(Data[33]+Data[34]*256);
         end;
      1: begin
           P1MinON.Text := IntToStr(Data[37]+Data[38]*256);
           P1MaxON.Text := IntToStr(Data[41]+Data[42]*256);
           P1MinOFF.Text := IntToStr(Data[45]+Data[46]*256);
           P1MaxOFF.Text := IntToStr(Data[49]+Data[50]*256);

           P2MinON.Text := IntToStr(Data[53]+Data[54]*256);
           P2MaxON.Text := IntToStr(Data[57]+Data[58]*256);
           P2MinOFF.Text := IntToStr(Data[61]+Data[62]*256);
           P2MaxOFF.Text := IntToStr(Data[65]+Data[66]*256);

           CyclesEdit.Text := IntToStr(Data[69]+Data[70]*256);
         end;
      2: begin
           P1MinON.Text := IntToStr(Data[73]+Data[74]*256);
           P1MaxON.Text := IntToStr(Data[77]+Data[78]*256);
           P1MinOFF.Text := IntToStr(Data[81]+Data[82]*256);
           P1MaxOFF.Text := IntToStr(Data[85]+Data[86]*256);

           P2MinON.Text := IntToStr(Data[89]+Data[90]*256);
           P2MaxON.Text := IntToStr(Data[93]+Data[94]*256);
           P2MinOFF.Text := IntToStr(Data[97]+Data[98]*256);
           P2MaxOFF.Text := IntToStr(Data[101]+Data[102]*256);

           CyclesEdit.Text := IntToStr(Data[105]+Data[106]*256);
         end;
      3: begin
           P1MinON.Text := IntToStr(Data[109]+Data[110]*256);
           P1MaxON.Text := IntToStr(Data[113]+Data[114]*256);
           P1MinOFF.Text := IntToStr(Data[117]+Data[118]*256);
           P1MaxOFF.Text := IntToStr(Data[121]+Data[122]*256);

           P2MinON.Text := IntToStr(Data[125]+Data[126]*256);
           P2MaxON.Text := IntToStr(Data[129]+Data[130]*256);
           P2MinOFF.Text := IntToStr(Data[133]+Data[134]*256);
           P2MaxOFF.Text := IntToStr(Data[137]+Data[138]*256);

           CyclesEdit.Text := IntToStr(Data[141]+Data[142]*256);
         end;
    end;
    Reg.CloseKey;

    // enable components
    ModeBox.Enabled := true;
    PhasesBox.Enabled := true;
    CyclesEdit.Enabled := true;
    SignalsBox.Enabled := true;
    SignModeLabel.Enabled := true;
    SignPhLabel.Enabled := true;
    SignCyclLabel.Enabled := true;
    SignSignLabel.Enabled := true;
    P1MinONLab.Enabled := true;
    P1MaxONLab.Enabled := true;
    P1MinOFFLab.Enabled := true;
    P1MaxOFFLab.Enabled := true;
    P1MinON.Enabled := true;
    P1MaxON.Enabled := true;
    P1MinOFF.Enabled := true;
    P1MaxOFF.Enabled := true;
    P1ms1Lab.Enabled := true;
    P1ms2Lab.Enabled := true;
    P1ms3Lab.Enabled := true;
    P1ms4Lab.Enabled := true;
  Except
    ModeBox.Enabled := false;
    PhasesBox.Enabled := false;
    CyclesEdit.Enabled := false;
    CyclesEdit.Text := 'Read Error!';
    SignalsBox.Enabled := false;
    SignModeLabel.Enabled := false;
    SignPhLabel.Enabled := false;
    SignCyclLabel.Enabled := false;
    SignSignLabel.Enabled := false;
    P1MinONLab.Enabled := false;
    P1MaxONLab.Enabled := false;
    P1MinOFFLab.Enabled := false;
    P1MaxOFFLab.Enabled := false;
    P1MinON.Enabled := false;
    P1MaxON.Enabled := false;
    P1MinOFF.Enabled := false;
    P1MaxOFF.Enabled := false;
    P1ms1Lab.Enabled := false;
    P1ms2Lab.Enabled := false;
    P1ms3Lab.Enabled := false;
    P1ms4Lab.Enabled := false;
    P2MinONLab.Enabled := false;
    P2MaxONLab.Enabled := false;
    P2MinOFFLab.Enabled := false;
    P2MaxOFFLab.Enabled := false;
    P2MinON.Enabled := false;
    P2MaxON.Enabled := false;
    P2MinOFF.Enabled := false;
    P2MaxOFF.Enabled := false;
    P2ms1Lab.Enabled := false;
    P2ms2Lab.Enabled := false;
    P2ms3Lab.Enabled := false;
    P2ms4Lab.Enabled := false;
  End;
  Reg.Free;
end;

procedure THCFForm.PhasesBoxChange(Sender: TObject);
begin
  If PhasesBox.ItemIndex = 0 then
  begin
    Phase2Box.Enabled := false;
    P2MinONLab.Enabled := false;
    P2MaxONLab.Enabled := false;
    P2MinOFFLab.Enabled := false;
    P2MaxOFFLab.Enabled := false;
    P2MinON.Enabled := false;
    P2MaxON.Enabled := false;
    P2MinOFF.Enabled := false;
    P2MaxOFF.Enabled := false;
    P2ms1Lab.Enabled := false;
    P2ms2Lab.Enabled := false;
    P2ms3Lab.Enabled := false;
    P2ms4Lab.Enabled := false;
  end
  Else
  begin
    Phase2Box.Enabled := true;
    P2MinONLab.Enabled := true;
    P2MaxONLab.Enabled := true;
    P2MinOFFLab.Enabled := true;
    P2MaxOFFLab.Enabled := true;
    P2MinON.Enabled := true;
    P2MaxON.Enabled := true;
    P2MinOFF.Enabled := true;
    P2MaxOFF.Enabled := true;
    P2ms1Lab.Enabled := true;
    P2ms2Lab.Enabled := true;
    P2ms3Lab.Enabled := true;
    P2ms4Lab.Enabled := true;
  end
end;

procedure THCFForm.CadenceChange(Sender: TObject);
begin
{
  SaveTabs(Sender);
}
end;

procedure THCFForm.ModeBoxChange(Sender: TObject);
begin
  SignUpdate(ResetBut);
  //   ,   
end;

procedure THCFForm.SignalsBoxChange(Sender: TObject);
begin
  SignUpdate(SigGraph);
  //        1-  
end;

procedure THCFForm.ReadInfo(Sender: TObject);
var
  Data : Array of Byte;
  sz : Word;
  T35 : Integer;
  DriverDate : String;
begin
  Try
    Reg := TRegistry.Create;
    Reg.RootKey := HKEY_LOCAL_MACHINE;
    Reg.OpenKeyReadOnly(ModemKey + PNP_Key + CountryWord);
    if Reg.ValueExists('CURRENT') then
    begin
      sz := Reg.GetDataSize('CURRENT');
      SetLength(Data, sz);
      Reg.ReadBinaryData('CURRENT', Data[0], sz);
      T35 := Data[0] + Data[1]*256;
      Case T35 of
        $00:  CurCountryEdit.Text := 'Japan';
        $01:  CurCountryEdit.Text := 'Albania';
        $02:  CurCountryEdit.Text := 'Algeria';
        $03:  CurCountryEdit.Text := 'American Samoa';
        $04:  CurCountryEdit.Text := 'Germany';
        $05:  CurCountryEdit.Text := 'Anguilla';
        $06:  CurCountryEdit.Text := 'Antigua and Barbuda';
        $07:  CurCountryEdit.Text := 'Argentina';
        $08:  CurCountryEdit.Text := 'Ascension';
        $09:  CurCountryEdit.Text := 'Australia';
        $0A:  CurCountryEdit.Text := 'Austria';
        $0B:  CurCountryEdit.Text := 'Bahamas';
        $0C:  CurCountryEdit.Text := 'Bahrain';
        $0D:  CurCountryEdit.Text := 'Bangladesh';
        $0E:  CurCountryEdit.Text := 'Barbados';
        $0F:  CurCountryEdit.Text := 'Belgium';
        $10:  CurCountryEdit.Text := 'Belize';
        $11:  CurCountryEdit.Text := 'Benin (Republic of)';
        $12:  CurCountryEdit.Text := 'Bermudas';
        $13:  CurCountryEdit.Text := 'Bhutan (Kingdom of)';
        $14:  CurCountryEdit.Text := 'Bolivia';
        $15:  CurCountryEdit.Text := 'Botswana';
        $16:  CurCountryEdit.Text := 'Brazil';
        $17:  CurCountryEdit.Text := 'British Antarctic Territory';
        $18:  CurCountryEdit.Text := 'British Indian Ocean Territory';
        $19:  CurCountryEdit.Text := 'British Virgin Islands';
        $1A:  CurCountryEdit.Text := 'Brunei Darussalam';
        $1B:  CurCountryEdit.Text := 'Bulgaria';
        $1C:  CurCountryEdit.Text := 'Caribbean';
        $1D:  CurCountryEdit.Text := 'Burundi';
        $1E:  CurCountryEdit.Text := 'Byelorussia';
        $1F:  CurCountryEdit.Text := 'Cameroon';
        $20:  CurCountryEdit.Text := 'Canada';
        $21:  CurCountryEdit.Text := 'Cape Verde';
        $22:  CurCountryEdit.Text := 'Cayman Islands';
        $23:  CurCountryEdit.Text := 'Central African Republic';
        $24:  CurCountryEdit.Text := 'Chad';
        $25:  CurCountryEdit.Text := 'Chile';
        $26:  CurCountryEdit.Text := 'China';
        $27:  CurCountryEdit.Text := 'Colombia';
        $28:  CurCountryEdit.Text := 'Comoros';
        $29:  CurCountryEdit.Text := 'Congo';
        $2A:  CurCountryEdit.Text := 'Cook Islands';
        $2B:  CurCountryEdit.Text := 'Costa Rica';
        $2C:  CurCountryEdit.Text := 'Cuba';
        $2D:  CurCountryEdit.Text := 'Cyprus';
        $2E:  CurCountryEdit.Text := 'Czech Federal Republic';
        $2F:  CurCountryEdit.Text := 'Cambodia';
        $30:  CurCountryEdit.Text := 'Democratic People''s Republic of Korea';
        $31:  CurCountryEdit.Text := 'Denmark';
        $32:  CurCountryEdit.Text := 'Djibouti';
        $33:  CurCountryEdit.Text := 'Dominican Republic';
        $34:  CurCountryEdit.Text := 'Dominica';
        $35:  CurCountryEdit.Text := 'Ecuador';
        $36:  CurCountryEdit.Text := 'Egypt';
        $37:  CurCountryEdit.Text := 'El Salvador';
        $38:  CurCountryEdit.Text := 'Equatorial Guinea';
        $39:  CurCountryEdit.Text := 'Ethiopia';
        $3A:  CurCountryEdit.Text := 'Falkland Islands';
        $3B:  CurCountryEdit.Text := 'Fiji';
        $3C:  CurCountryEdit.Text := 'Finland';
        $3D:  CurCountryEdit.Text := 'France';
        $3E:  CurCountryEdit.Text := 'French Polynesia';
        $3F:  CurCountryEdit.Text := 'French Southern and Antarctic Lands';
        $40:  CurCountryEdit.Text := 'Gabon';
        $41:  CurCountryEdit.Text := 'Gambia';
        $42:  CurCountryEdit.Text := 'Germany (Federal Republic of)';
        $43:  CurCountryEdit.Text := 'Angola';
        $44:  CurCountryEdit.Text := 'Ghana';
        $45:  CurCountryEdit.Text := 'Gibraltar';
        $46:  CurCountryEdit.Text := 'Greece';
        $47:  CurCountryEdit.Text := 'Grenada';
        $48:  CurCountryEdit.Text := 'Guam';
        $49:  CurCountryEdit.Text := 'Guatemala';
        $4A:  CurCountryEdit.Text := 'Guernsey';
        $4B:  CurCountryEdit.Text := 'Guinea';
        $4C:  CurCountryEdit.Text := 'Guinea-Bissau';
        $4D:  CurCountryEdit.Text := 'Guayana';
        $4E:  CurCountryEdit.Text := 'Haiti';
        $4F:  CurCountryEdit.Text := 'Honduras';
        $50:  CurCountryEdit.Text := 'Hong Kong';
        $51:  CurCountryEdit.Text := 'Hungary';
        $52:  CurCountryEdit.Text := 'Iceland';
        $53:  CurCountryEdit.Text := 'India';
        $54:  CurCountryEdit.Text := 'Indonesia';
        $55:  CurCountryEdit.Text := 'Iran (Islamic Republic of)';
        $56:  CurCountryEdit.Text := 'Iraq';
        $57:  CurCountryEdit.Text := 'Ireland';
        $58:  CurCountryEdit.Text := 'Israel';
        $59:  CurCountryEdit.Text := 'Italy';

        $61:  CurCountryEdit.Text := 'Korea';
        $62:  CurCountryEdit.Text := 'Kuwait';
        $63:  CurCountryEdit.Text := 'Lao (People''s Democratic Republic)';
        $64:  CurCountryEdit.Text := 'Lebanon';
        $65:  CurCountryEdit.Text := 'Lesotho';
        $66:  CurCountryEdit.Text := 'Liberia';
        $67:  CurCountryEdit.Text := 'Libya';
        $68:  CurCountryEdit.Text := 'Liechtenstein';
        $69:  CurCountryEdit.Text := 'Luxemborg';
        $6A:  CurCountryEdit.Text := 'Macao';
        $6B:  CurCountryEdit.Text := 'Madagascar';
        $6C:  CurCountryEdit.Text := 'Malaysia';
        $6D:  CurCountryEdit.Text := 'Malawi';
        $6E:  CurCountryEdit.Text := 'Maldives';
        $6F:  CurCountryEdit.Text := 'Mali';
        $70:  CurCountryEdit.Text := 'Malta';
        $71:  CurCountryEdit.Text := 'Mauritania';
        $72:  CurCountryEdit.Text := 'Mauritius';
        $73:  CurCountryEdit.Text := 'Mexico';
        $74:  CurCountryEdit.Text := 'Monaco';
        $75:  CurCountryEdit.Text := 'Mongolia';
        $76:  CurCountryEdit.Text := 'Montserrat';
        $77:  CurCountryEdit.Text := 'Morocco';
        $78:  CurCountryEdit.Text := 'Mozambique';
        $79:  CurCountryEdit.Text := 'Nauru';
        $7A:  CurCountryEdit.Text := 'Nepal';
        $7B:  CurCountryEdit.Text := 'Netherland';
        $7C:  CurCountryEdit.Text := 'Netherlands Antilles';
        $7D:  CurCountryEdit.Text := 'New Caledonia';
        $7E:  CurCountryEdit.Text := 'New Zealand';
        $7F:  CurCountryEdit.Text := 'Nicaragua';
        $80:  CurCountryEdit.Text := 'Niger';
        $81:  CurCountryEdit.Text := 'Nigeria';
        $82:  CurCountryEdit.Text := 'Norway';
        $83:  CurCountryEdit.Text := 'Oman';
        $84:  CurCountryEdit.Text := 'Pakistan';
        $85:  CurCountryEdit.Text := 'Panama';
        $86:  CurCountryEdit.Text := 'Papua New Guinea';
        $87:  CurCountryEdit.Text := 'Paraguay';
        $88:  CurCountryEdit.Text := 'Peru';
        $89:  CurCountryEdit.Text := 'Philippines';
        $8A:  CurCountryEdit.Text := 'Poland';
        $8B:  CurCountryEdit.Text := 'Portugal';
        $9C:  CurCountryEdit.Text := 'Singapore';
        $9D:  CurCountryEdit.Text := 'Solomon Islands';
        $9E:  CurCountryEdit.Text := 'Somalia';
        $9F:  CurCountryEdit.Text := 'South Africa';
        $A0:  CurCountryEdit.Text := 'Spain';
        $A1:  CurCountryEdit.Text := 'Sri Lanka';
        $A2:  CurCountryEdit.Text := 'Sudan';
        $A3:  CurCountryEdit.Text := 'Suriname';
        $A4:  CurCountryEdit.Text := 'Swaziland';
        $A5:  CurCountryEdit.Text := 'Sweden';
        $A6:  CurCountryEdit.Text := 'Switherland';
        $A7:  CurCountryEdit.Text := 'Syria';
        $A8:  CurCountryEdit.Text := 'Tanzania';
        $A9:  CurCountryEdit.Text := 'Thailand';
        $AA:  CurCountryEdit.Text := 'Togo';
        $AB:  CurCountryEdit.Text := 'Tonga';
        $AC:  CurCountryEdit.Text := 'Trinidad and Tobago';
        $AD:  CurCountryEdit.Text := 'Tunisia';
        $AE:  CurCountryEdit.Text := 'Turkey';
        $AF:  CurCountryEdit.Text := 'Turks and Caicos Islands';
        $B0:  CurCountryEdit.Text := 'Tuvalu';
        $B1:  CurCountryEdit.Text := 'Uganda';
        $B2:  CurCountryEdit.Text := 'Ukraine';
        $B3:  CurCountryEdit.Text := 'United Arab Emirates';
        $B4:  CurCountryEdit.Text := 'United Kingdom';
        $B5:  CurCountryEdit.Text := 'United States of America';
        $B6:  CurCountryEdit.Text := 'Burkina Faso';
        $B7:  CurCountryEdit.Text := 'Uruguay';
        $B8:  CurCountryEdit.Text := 'Russian Federation';
        $B9:  CurCountryEdit.Text := 'Vanuatu';
        $BA:  CurCountryEdit.Text := 'Vatican City State';
        $BB:  CurCountryEdit.Text := 'Venezuela';
        $BC:  CurCountryEdit.Text := 'Vietnam';
        $BD:  CurCountryEdit.Text := 'Wallis and Futuna';
        $BE:  CurCountryEdit.Text := 'Western Samoa';
        $BF:  CurCountryEdit.Text := 'Yemen (Republic of)';
        $C0:  CurCountryEdit.Text := 'Yemen (Republic of)';
        $C1:  CurCountryEdit.Text := 'Yugoslavia';
        $C2:  CurCountryEdit.Text := 'Zaire';
        $C3:  CurCountryEdit.Text := 'Zambia';
        $C4:  CurCountryEdit.Text := 'Zimbabwe';
        $C5:  CurCountryEdit.Text := 'Yemen (Republic of)';
        $C6:  CurCountryEdit.Text := 'Slovakia';
        $C7:  CurCountryEdit.Text := 'Slovenia';

        $FE:  CurCountryEdit.Text := 'Taiwan';
      else CurCountryEdit.Text := 'Unknown';
      end;
      Reg.CloseKey;
    end
    else CurCountryEdit.Text := 'Not Detected';
//  ---
    Reg.OpenKeyReadOnly('\System\CurrentControlSet\Services\Class\Modem\' + PNP_Key + '\');
    if Reg.ValueExists('Model') then ModModelEdit.Text := Reg.ReadString('Model') else ModModelEdit.Text := 'Not Detected';
    //if Reg.ValueExists('HardwareID') then HardEdit.Text := Reg.ReadString('HardwareID') else HardEdit.Text := 'Not Detected';
    if Reg.ValueExists('MatchingDeviceId') then HardEdit.Text := Reg.ReadString('MatchingDeviceId') else HardEdit.Text := 'Not Detected';
    DriverDate := '(' + Reg.ReadString('DriverDate') + ')';
    Reg.CloseKey;
//  ---
    Reg.OpenKeyReadOnly('\System\CurrentControlSet\Services\Class\Modem\' + PNP_Key + '\OEM\ATI\');
    if (Reg.ValueExists('3') and (Reg.ReadString('3') <> '')) then DrVerEdit.Text := Reg.ReadString('3') + '  ' + DriverDate
    else DrVerEdit.Text := DriverDate;
    if Reg.ValueExists('4') then OemStEdit.Text := Reg.ReadString('4') else OemStEdit.Text := 'Not Detected';
    Reg.CloseKey;
  Finally
    Reg.Free;
  end;
end;

procedure THCFForm.Mail2Autor(Sender: TObject);
begin
  ShellExecute(Handle,'open',pChar('mailto:gza_faq@mail.ru'),'','',SW_SHOW);
end;

procedure THCFForm.OpenSupportPage(Sender: TObject);
begin
  ShellExecute(Handle,'open',pChar('http://hcfconf.cjb.net/'),'','',SW_SHOW);
end;

procedure THCFForm.FormCreate(Sender: TObject);
begin
  Application.OnMinimize := TrayForm;
  RxTrayIcon.Icon := HCFForm.Icon;
  HCFForm.Initialize(Sender);
  HCFForm.ResetTabs(Sender);
  Tap1:=TTapiDial.Create(Self);
  Tap1.CallDialog:=Win95;
  Tap1.StatusWindow:=True;
end;

procedure THCFForm.TrayForm(Sender: TObject);
begin
  ShowWindow(Application.Handle, SW_HIDE);
  ShowWindow(Application.MainForm.Handle, SW_HIDE);
  RxTrayIcon.Show;
end;

procedure THCFForm.ShowForm(Sender: TObject);
begin
  RxTrayIcon.Hide;
  ShowWindow(Application.Handle, SW_RESTORE);
  ShowWindow(Application.MainForm.Handle, SW_RESTORE);
end;

procedure THCFForm.Initialize(Sender: TObject);
begin
  MyRegistry := TRegistry.Create;
  MyRegistry.RootKey := HKEY_CURRENT_USER;
  If not MyRegistry.OpenKey('\Software\HCF Configurator' , True) then Halt(1);

  If MyRegistry.ValueExists('Tabs') then
  begin
    //    
    Tabs := MyRegistry.ReadString('Tabs');
    if Tabs[1] = '0' then
    begin
      MenInfo.Checked := false;
      Pages.Pages[0].TabVisible := false;
    end;
    if Tabs[2] = '0' then
    begin
      MenInits.Checked := false;
      Pages.Pages[1].TabVisible := false;
    end;
    if Tabs[3] = '0' then
    begin
      MenTransmit.Checked := false;
      Pages.Pages[2].TabVisible := false;
    end;
    if Tabs[4] = '0' then
    begin
      MenRegisters.Checked := false;
      Pages.Pages[3].TabVisible := false;
    end;
    if Tabs[5] = '0' then
    begin
      MenSignals.Checked := false;
      Pages.Pages[4].TabVisible := false;
    end;
    if Tabs[6] = '0' then
    begin
      MenTiming.Checked := false;
      Pages.Pages[5].TabVisible := false;
    end;
    if Tabs[7] = '0' then
    begin
      MenBlacklist.Checked := false;
      Pages.Pages[6].TabVisible := false;
    end;
    if Tabs[8] = '0' then
    begin
      MenMonitoring.Checked := false;
      Pages.Pages[7].TabVisible := false;
    end;
    if Tabs[9] = '0' then
    begin
      MenStatistics.Checked := false;
      Pages.Pages[8].TabVisible := false;
    end;
    HCFForm.PagesVisible(Sender);
  end;

  If (MyRegistry.ValueExists('COM Port') and MyRegistry.ValueExists('PnP Key') and MyRegistry.ValueExists('Country Key')) then
  begin
    //  -,    
    If MyRegistry.ValueExists('COM Port') then
    Case MyRegistry.ReadInteger('COM Port') of
      1: HCFForm.COMChange(COM11);
      2: HCFForm.COMChange(COM21);
      3: HCFForm.COMChange(COM31);
      4: HCFForm.COMChange(COM41);
      5: HCFForm.COMChange(COM51);
      6: HCFForm.COMChange(COM61);
    end;
    //  Plug and Play ,    
    If MyRegistry.ValueExists('PnP Key') then
    begin
      PNP_Key := MyRegistry.ReadString('PnP Key');
      HCFForm.PnPChange(Sender);
    end;
    //  Country ,    
    If MyRegistry.ValueExists('Country Key') then
    begin
      Country_Key := MyRegistry.ReadString('Country Key');
      HCFForm.CountryChange(Sender);
    end;
    //     
    If (MyRegistry.ValueExists ('WinPosLeft')) and (MyRegistry.ValueExists ('WinPosTop')) then
    begin
      HCFForm.Left := MyRegistry.ReadInteger('WinPosLeft');
      HCFForm.Top := MyRegistry.ReadInteger('WinPosTop');
    end;
  end
  else
  begin
    HCFForm.Position := poDesktopCenter;
    HCFForm.Autodetection(Sender);
  end;
  MyRegistry.Free;
  //HCFForm.LanguageLoading(Sender);
end;

procedure THCFForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  MyRegistry := TRegistry.Create;
  MyRegistry.RootKey := HKEY_CURRENT_USER;
  HCFForm.ReadTabs(Sender);
  If not MyRegistry.OpenKey('\Software\HCF Configurator' , True) then Halt(1);
  Try
    MyRegistry.WriteInteger('COM Port', StrToInt(ComPort[4]));
    MyRegistry.WriteString('PnP Key', PnP_Key);
    MyRegistry.WriteString('Country Key', Country_Key);
    MyRegistry.WriteString('Tabs', Tabs);
    MyRegistry.WriteInteger('WinPosLeft', HCFForm.Left);
    MyRegistry.WriteInteger('WinPosTop', HCFForm.Top);
  Except
    Halt(1);
  End;
end;

procedure THCFForm.PnPChange(Sender: TObject);
begin
  PnP0000.Checked := false;
  PnP0001.Checked := false;
  PnP0002.Checked := false;
  PnP0003.Checked := false;
  PnP0004.Checked := false;
  PnP0005.Checked := false;
  PnPCustom.Checked := false;
  if Sender = PnP0000 then PNP_Key := '0000';
  if Sender = PnP0001 then PNP_Key := '0001';
  if Sender = PnP0002 then PNP_Key := '0002';
  if Sender = PnP0003 then PNP_Key := '0003';
  if Sender = PnP0004 then PNP_Key := '0004';
  if Sender = PnP0005 then PNP_Key := '0005';
  //if Sender = PnPCustom then beep;
  case StrToInt('$' + PNP_Key) of
    0: PnP0000.Checked := true;
    1: PnP0001.Checked := true;
    2: PnP0002.Checked := true;
    3: PnP0003.Checked := true;
    4: PnP0004.Checked := true;
    5: PnP0005.Checked := true;
    else PnPCustom.Checked := true;
  end;
  PnPCustom.Caption := '&Custom...' + ' [' + PNP_Key + ']';
  HCFForm.ResetTabs(Sender);
end;

procedure THCFForm.ReadTiming(Sender: TObject);
var
  Data : Array of Byte;
  sz : Word;
begin
  Reg := TRegistry.Create;
  Reg.RootKey := HKEY_LOCAL_MACHINE;
  try
    Reg.OpenKeyReadOnly(ModemKey + PNP_Key + CountryWord + Country_Key);
    if Reg.ValueExists(TimingKey) then
    begin
      sz := Reg.GetDataSize(TimingKey);
      SetLength(Data, sz);
      Reg.ReadBinaryData(TimingKey, Data[0], sz);

      Delay1Edit.ReadOnly := false;
      Delay2Edit.ReadOnly := false;
      Delay3Edit.ReadOnly := false;
      Delay4Edit.ReadOnly := false;

      Delay1Edit.Text := IntToStr(Data[1]*256 + Data[0]);
      Delay2Edit.Text := IntToStr(Data[3]*256 + Data[2]);
      Delay3Edit.Text := IntToStr(Data[5]*256 + Data[4]);
      Delay4Edit.Text := IntToStr(Data[7]*256 + Data[6]);
    end
    else
    begin
      Delay1Edit.ReadOnly := true;
      Delay2Edit.ReadOnly := true;
      Delay3Edit.ReadOnly := true;
      Delay4Edit.ReadOnly := true;
      Delay1Edit.Text := 'Error';
      Delay2Edit.Text := 'Error';
      Delay3Edit.Text := 'Error';
      Delay4Edit.Text := 'Error';
    end;

    if Reg.ValueExists(TimingKey) then
    begin
      sz := Reg.GetDataSize(ToneKey);
      SetLength(Data, sz);
      Reg.ReadBinaryData(ToneKey, Data[0], sz);

      Detect1Edit.ReadOnly := false;
      Detect2Edit.ReadOnly := false;

      Detect1Edit.Text := IntToStr(Data[1]*256 + Data[0]);
      Detect2Edit.Text := IntToStr(Data[3]*256 + Data[2]);
    end
    else
    begin
      Detect1Edit.ReadOnly := true;
      Detect2Edit.ReadOnly := true;
      Detect1Edit.Text := 'Error';
      Detect2Edit.Text := 'Error';
    end;
  finally
    Reg.CloseKey;
  end;
  Reg.Free;
end;

procedure THCFForm.AggressivenessChange(Sender: TObject);
begin
  if AggressivenessRadioBtn1.Checked then
  begin
    LineQualityBox.Enabled := true;
    CustomMaskL.Enabled := false;
    CustomMaskR.Enabled := false;
    BLERLabel.Enabled := false;
    PerCentLabel.Enabled := false;
    TenLabel.Enabled := false;
  end
  else
  begin
    LineQualityBox.Enabled := false;
    CustomMaskL.Enabled := true;
    CustomMaskR.Enabled := true;
    BLERLabel.Enabled := true;
    PerCentLabel.Enabled := true;
    TenLabel.Enabled := true;
  end;
end;

procedure THCFForm.CalculateAggressiveness(Sender: TObject);
var
  j: byte;
  BLER: real;
  Step: Integer;
begin
  try
    if ((StrToInt(CustomMaskR.Text) > 15) or (StrToInt(CustomMaskR.Text) < 0) or (StrToInt(CustomMaskL.Text) > 15) or (StrToInt(CustomMaskL.Text) < 0)) then raise ERangeError.CreateFmt('', []);
    Step := 1;
    if (StrToInt(CustomMaskR.Text) <> 0) then for j := 1 to StrToInt(CustomMaskR.Text) do Step := Step * 10;
    BLER := (StrToInt(CustomMaskL.Text)) / Step;
    BLERLabel.Caption := '= ' + FloatToStr(BLER) + '%';

    LineQualityBox.Items[0] := 'Perfect Line';

    if ((BLER <= 15) and (BLER >= 10)) then LineQualityBox.ItemIndex := 0;
    if ((BLER < 10) and (BLER >= 2)) then LineQualityBox.ItemIndex := 1;
    if ((BLER < 2) and (BLER >= 0.1)) then LineQualityBox.ItemIndex := 2;
    if ((BLER < 0.1) and (BLER >= 0.0003)) then LineQualityBox.ItemIndex := 3;
    if ((BLER < 0.0003) and (BLER >= -100)) then LineQualityBox.ItemIndex := 4;

    SpeedAdj[ProtocolBox.ItemIndex] := StrToInt(CustomMaskL.Text) * $10 + StrToInt(CustomMaskR.Text);
  except
    BLERLabel.Caption := '= N/A';
    LineQualityBox.Items[0] := 'Error';
    LineQualityBox.ItemIndex := 0;
  end;
end;

procedure THCFForm.ShowHelp(Sender: TObject);
begin
  ShellExecute(Handle,'open',pChar(Application.HelpFile),'','',SW_SHOW);
end;

procedure THCFForm.Autodetection(Sender: TObject);
var
  Data : Array [0..1] of Byte;
  pnp: Integer;
  cnt: Integer;
  RealCnt, CurCnt : Integer;
  Slack: String;
  numb: Byte;
begin
  Reg := TRegistry.Create;
  Reg.RootKey := HKEY_LOCAL_MACHINE;
  for pnp := 0 to $FFFF do
  case pnp of
    0..$F:        try
                    numb := 1;
                    if (Reg.OpenKeyReadOnly(ModemKey + '000' + Dec2Hex(pnp, numb) + '\OEM') and Reg.OpenKeyReadOnly(ModemKey + '000' + Dec2Hex(pnp, numb) + '\COUNTRY')) then
                    begin
                      PNP_Key := '000' + Dec2Hex(pnp, numb);
                      Reg.RootKey := HKEY_CURRENT_USER;
                      Reg.OpenKey('\Software\HCF Configurator' , True);
                      Reg.WriteString('PnP Key', PnP_Key);
                      Reg.CloseKey;
                      PnPDetected := true;
                      Break;
                    end;
                  except
                  end;
    $10..$FF:     try
                    numb := 2;
                    if (Reg.OpenKeyReadOnly(ModemKey + '00' + Dec2Hex(pnp, numb) + '\OEM') and Reg.OpenKeyReadOnly(ModemKey + '00' + Dec2Hex(pnp, numb) + '\COUNTRY')) then
                    begin
                      PNP_Key := '00' + Dec2Hex(pnp, numb);
                      Reg.RootKey := HKEY_CURRENT_USER;
                      Reg.OpenKey('\Software\HCF Configurator' , True);
                      Reg.WriteString('PnP Key', PnP_Key);
                      Reg.CloseKey;
                      PnPDetected := true;
                      Break;
                    end;
                  except
                  end;
    $100..$FFF:   try
                    numb := 3;
                    if (Reg.OpenKeyReadOnly(ModemKey + '0' + Dec2Hex(pnp, numb) + '\OEM') and Reg.OpenKeyReadOnly(ModemKey + '0' + Dec2Hex(pnp, numb) + '\COUNTRY')) then
                    begin
                      PNP_Key := '0' + Dec2Hex(pnp, numb);
                      Reg.RootKey := HKEY_CURRENT_USER;
                      Reg.OpenKey('\Software\HCF Configurator' , True);
                      Reg.WriteString('PnP Key', PnP_Key);
                      Reg.CloseKey;
                      PnPDetected := true;
                      Break;
                    end;
                  except
                  end;
    $1000..$FFFF: try
                    numb := 4;
                    if (Reg.OpenKeyReadOnly(ModemKey + Dec2Hex(pnp, numb) + '\OEM') and Reg.OpenKeyReadOnly(ModemKey + Dec2Hex(pnp, numb) + '\COUNTRY')) then
                    begin
                      PNP_Key := Dec2Hex(pnp, numb);
                      Reg.RootKey := HKEY_CURRENT_USER;
                      Reg.OpenKey('\Software\HCF Configurator' , True);
                      Reg.WriteString('PnP Key', PnP_Key);
                      Reg.CloseKey;
                      PnPDetected := true;
                      Break;
                    end;
                  except
                  end;
  end;

  Reg.RootKey := HKEY_LOCAL_MACHINE;
  Reg.OpenKeyReadOnly(ModemKey + PNP_Key + CountryWord);
  Reg.ReadBinaryData('CURRENT', Data[0], 2);
  Reg.CloseKey;
  RealCnt := Data[0] + Data[1]*256;

  for cnt := 0 to $FFFF do
  case cnt of
    0..$F:        try
                    numb := 1;
                    Slack := '000' + Dec2Hex(cnt, numb);
                    if Reg.OpenKeyReadOnly(ModemKey + PNP_Key + CountryWord + Slack) then
                    begin
                      Reg.ReadBinaryData('T35CODE', Data[0], 2);
                      CurCnt := Data[0] + Data[1]*256;
                      if RealCnt = CurCnt then
                      begin
                        Country_Key := Slack;
                        Reg.RootKey := HKEY_CURRENT_USER;
                        Reg.OpenKey('\Software\HCF Configurator' , True);
                        Reg.WriteInteger('Country Key', StrToInt('$' + Country_Key));
                        Reg.CloseKey;
                        CntDetected := true;
                        Break;
                      end;
                    end;
                  except
                  end;
    $10..$FF:     try
                    numb := 2;
                    Slack := '00' + Dec2Hex(cnt, numb);
                    if Reg.OpenKeyReadOnly(ModemKey + PNP_Key + CountryWord + Slack) then
                    begin
                      Reg.ReadBinaryData('T35CODE', Data[0], 2);
                      CurCnt := Data[0] + Data[1]*256;
                      if RealCnt = CurCnt then
                      begin
                        Country_Key := Slack;
                        Reg.RootKey := HKEY_CURRENT_USER;
                        Reg.OpenKey('\Software\HCF Configurator' , True);
                        Reg.WriteInteger('Country Key', StrToInt('$' + Country_Key));
                        Reg.CloseKey;
                        CntDetected := true;
                        Break;
                      end;
                    end;
                  except
                  end;
    $100..$FFF:   try
                    numb := 3;
                    Slack := '0' + Dec2Hex(cnt, numb);
                    if Reg.OpenKeyReadOnly(ModemKey + PNP_Key + CountryWord + Slack) then
                    begin
                      Reg.ReadBinaryData('T35CODE', Data[0], 2);
                      CurCnt := Data[0] + Data[1]*256;
                      if RealCnt = CurCnt then
                      begin
                        Country_Key := Slack;
                        Reg.RootKey := HKEY_CURRENT_USER;
                        Reg.OpenKey('\Software\HCF Configurator' , True);
                        Reg.WriteInteger('Country Key', StrToInt('$' + Country_Key));
                        Reg.CloseKey;
                        CntDetected := true;
                        Break;
                      end;
                    end;
                  except
                  end;
    $1000..$FFFF: try
                    numb := 4;
                    Slack := Dec2Hex(cnt, numb);
                    if Reg.OpenKeyReadOnly(ModemKey + PNP_Key + CountryWord + Slack) then
                    begin
                      Reg.ReadBinaryData('T35CODE', Data[0], 2);
                      CurCnt := Data[0] + Data[1]*256;
                      if RealCnt = CurCnt then
                      begin
                        Country_Key := Slack;
                        Reg.RootKey := HKEY_CURRENT_USER;
                        Reg.OpenKey('\Software\HCF Configurator' , True);
                        Reg.WriteInteger('Country Key', StrToInt('$' + Country_Key));
                        Reg.CloseKey;
                        CntDetected := true;
                        Break;
                      end;
                    end;
                  except
                  end;
  end;

  if not (CntDetected and PnPDetected) then MessageDlg('HCF Configurator can''t find HCF or HSF modem on the computer.'+#13#10+'Possible, modem drivers not installed.'+#13#10+'Program can not work properly!', mtWarning, [mbOK], 0);

  Reg.Free;
  HCFForm.PnPChange(Sender);
  HCFForm.CountryChange(Sender);
end;

function THCFForm.Dec2Hex(DecInt: Integer; numbers: byte) : string;
var
  remainder: Byte;
begin
  if numbers > 1 then
  begin
    remainder := DecInt mod $10;
    DecInt := (DecInt - remainder) div $10;
    Dec(numbers);
    Result := Dec2Hex(DecInt, numbers) + D2H(remainder);
  end
  else Result := D2H(DecInt);
end;

function THCFForm.D2H(Dec: Byte): char;
begin
  case Dec of
    0: Result := '0';
    1: Result := '1';
    2: Result := '2';
    3: Result := '3';
    4: Result := '4';
    5: Result := '5';
    6: Result := '6';
    7: Result := '7';
    8: Result := '8';
    9: Result := '9';
    10: Result := 'A';
    11: Result := 'B';
    12: Result := 'C';
    13: Result := 'D';
    14: Result := 'E';
    15: Result := 'F';
  end;
end;

procedure THCFForm.PnPCustomClick(Sender: TObject);
var
  zzz: Integer;
  numb: Byte;

begin
  try
    zzz := StrToInt('$'+InputBox('Plug and Play Key Customizing', 'Key must fall within from 0000 to FFFF', PnP_Key));
    if ((zzz < 0) or (zzz > $FFFF)) then raise ERangeError.CreateFmt('', []);
    case zzz of
      0..$F:        begin
                      numb := 1;
                      PNP_Key := '000' + Dec2Hex(zzz, numb);
                    end;
      $10..$FF:     begin
                      numb := 2;
                      PNP_Key := '00' + Dec2Hex(zzz, numb);
                    end;
      $100..$FFF:   begin
                      numb := 3;
                      PNP_Key := '0' + Dec2Hex(zzz, numb);
                    end;
      $1000..$FFFF: begin
                      numb := 4;
                      PNP_Key := Dec2Hex(zzz, numb);
                    end;
    end;
    //ShowMessage(PNP_Key);
    PnPChange(Sender);
  except
    MessageDlg('Please, enter only 4 positive hexadecimal numerals!', mtError, [mbOK], 0);
  end;
end;

procedure THCFForm.CountryChange(Sender: TObject);
begin
  Country0000.Checked:=false;
  Country0001.Checked:=false;
  Country0002.Checked:=false;
  Country0003.Checked:=false;
  Country0004.Checked:=false;
  Country0005.Checked:=false;
  CountryCustom.Checked:=false;
  if Sender = Country0000 then Country_Key := '0000';
  if Sender = Country0001 then Country_Key := '0001';
  if Sender = Country0002 then Country_Key := '0002';
  if Sender = Country0003 then Country_Key := '0003';
  if Sender = Country0004 then Country_Key := '0004';
  if Sender = Country0005 then Country_Key := '0005';
  case StrToInt('$' + Country_Key) of
    0: Country0000.Checked := true;
    1: Country0001.Checked := true;
    2: Country0002.Checked := true;
    3: Country0003.Checked := true;
    4: Country0004.Checked := true;
    5: Country0005.Checked := true;
    else CountryCustom.Checked := true;
  end;
  CountryCustom.Caption := '&Custom...' + ' [' + Country_Key + ']';
  HCFForm.ResetTabs(Sender);
end;

procedure THCFForm.CountryCustomClick(Sender: TObject);
var
  zzz: Integer;
  numb: Byte;
begin
  try
    zzz := StrToInt('$'+InputBox('Country Key Customizing', 'Key must fall within from 0000 to FFFF', Country_Key));
    if ((zzz < 0) or (zzz > $FFFF)) then raise ERangeError.CreateFmt('', []);
    case zzz of
      0..$F:        begin
                      numb := 1;
                      Country_Key := '000' + Dec2Hex(zzz, numb);
                    end;
      $10..$FF:     begin
                      numb := 2;
                      Country_Key := '00' + Dec2Hex(zzz, numb);
                    end;
      $100..$FFF:   begin
                      numb := 3;
                      Country_Key := '0' + Dec2Hex(zzz, numb);
                    end;
      $1000..$FFFF: begin
                      numb := 4;
                      Country_Key := Dec2Hex(zzz, numb);
                    end;
    end;
    CountryChange(Sender);
  except
    MessageDlg('Please, enter only 4 positive hexadecimal numerals!', mtError, [mbOK], 0);
  end;
end;

procedure THCFForm.ModProtocolBoxChange(Sender: TObject);
var
  Data : Array of Byte;
  //sz : Word;
  //az: byte;

begin
  Reg.OpenKeyReadOnly(ModemKey + PNP_Key + OEMKey);
  SetLength(Data, 24);
  Reg.ReadBinaryData('AT+MS', Data[0], 24);
  if Data[4] = 0 then ModNegCheckBox.Checked := false else ModNegCheckBox.Checked := true;
  case Data[0] of
    $00: ModProtocolBox.ItemIndex := 5;
    $01: ModProtocolBox.ItemIndex := 4;

    $20: ModProtocolBox.ItemIndex := 3;
    $22: ModProtocolBox.ItemIndex := 2;
    $38: ModProtocolBox.ItemIndex := 1;
    $5A: begin
           ModProtocolBox.ItemIndex := 1;
           ModTXMinBox.Clear;
           ModTXMaxBox.Clear;
           ModRXMinBox.Clear;
           ModRXMaxBox.Clear;
           ModTXMinBox.Items.CommaText := '28000 29333 30667 32000 33333 34667 36000 37333 38667 40000 41333 42667 45333 46667 48000 49333 50667 52000 53333 54667 56000';
         end;
  end;
  Reg.CloseKey;
end;

procedure THCFForm.PagesVisible(Sender: TObject);
begin
  if Sender = MenInfo then
  begin
    MenInfo.Checked := not MenInfo.Checked;
    Pages.Pages[0].TabVisible := MenInfo.Checked;
  end;
  if Sender = MenInits then
  begin
    MenInits.Checked := not MenInits.Checked;
    Pages.Pages[1].TabVisible := MenInits.Checked;
  end;
  if Sender = MenTransmit then
  begin
    MenTransmit.Checked := not MenTransmit.Checked;
    Pages.Pages[2].TabVisible := MenTransmit.Checked;
  end;
  if Sender = MenRegisters then
  begin
    MenRegisters.Checked := not MenRegisters.Checked;
    Pages.Pages[3].TabVisible := MenRegisters.Checked;
  end;
  if Sender = MenSignals then
  begin
    MenSignals.Checked := not MenSignals.Checked;
    Pages.Pages[4].TabVisible := MenSignals.Checked;
  end;
  if Sender = MenTiming then
  begin
    MenTiming.Checked := not MenTiming.Checked;
    Pages.Pages[5].TabVisible := MenTiming.Checked;
  end;
  if Sender = MenBlacklist then
  begin
    MenBlacklist.Checked := not MenBlacklist.Checked;
    Pages.Pages[6].TabVisible := MenBlacklist.Checked;
  end;
  if Sender = MenMonitoring then
  begin
    MenMonitoring.Checked := not MenMonitoring.Checked;
    Pages.Pages[7].TabVisible := MenMonitoring.Checked;
  end;
  if Sender = MenStatistics then
  begin
    MenStatistics.Checked := not MenStatistics.Checked;
    Pages.Pages[8].TabVisible := MenStatistics.Checked;
  end;
  if not (MenInfo.Checked or MenInits.Checked or MenTransmit.Checked or MenRegisters.Checked or MenSignals.Checked or MenTiming.Checked or MenBlacklist.Checked or MenMonitoring.Checked or MenStatistics.Checked) then
  begin
    CanHideSplash := false;
    HCFForm.About(Sender);
  end
  else CanHideSplash := true;
  HCFForm.ResetTabs(Sender);
end;

procedure THCFForm.SpeedButton1Click(Sender: TObject);
begin
  Tap1.ConfigDialog;
end;

procedure THCFForm.SpeedButton2Click(Sender: TObject);
begin
  Tap1.TranslateDialog;
end;

procedure THCFForm.ReadTabs(Sender: TObject);
begin
    if MenInfo.Checked then Tabs[1] := '1' else Tabs[1] := '0';
    if MenInits.Checked then Tabs[2] := '1' else Tabs[2] := '0';
    if MenTransmit.Checked then Tabs[3] := '1' else Tabs[3] := '0';
    if MenRegisters.Checked then Tabs[4] := '1' else Tabs[4] := '0';
    if MenSignals.Checked then Tabs[5] := '1' else Tabs[5] := '0';
    if MenTiming.Checked then Tabs[6] := '1' else Tabs[6] := '0';
    if MenBlacklist.Checked then Tabs[7] := '1' else Tabs[7] := '0';
    if MenMonitoring.Checked then Tabs[8] := '1' else Tabs[8] := '0';
    if MenStatistics.Checked then Tabs[9] := '1' else Tabs[9] := '0';
end;

procedure THCFForm.LanguageLoading(Sender: TObject);
begin
  if Sender = English1 then Languages1.Bitmap := English1.Bitmap;
  if Sender = Deutsch1 then Languages1.Bitmap := Deutsch1.Bitmap;
  if Sender = Russian1 then
  begin
    Languages1.Bitmap := Russian1.Bitmap;
    with Russian do
    begin
      File1.Caption := Menu_File[1];
      File_Autodetection.Caption := Menu_File[2];
      File_Save.Caption := Menu_File[3];
      File_Savetofile.Caption := Menu_File[4];
      File_Reset.Caption := Menu_File[5];
      File_Exit.Caption := Menu_File[6];

      View1.Caption := Menu_View[1];
      Pages1.Caption := Menu_View[2];
      MenInfo.Caption := Menu_View[3];
      MenInits.Caption := Menu_View[4];
      MenTransmit.Caption := Menu_View[5];
      MenRegisters.Caption := Menu_View[6];
      MenSignals.Caption := Menu_View[7];
      MenTiming.Caption := Menu_View[8];
      MenBlacklist.Caption := Menu_View[9];
      MenMonitoring.Caption := Menu_View[10];
      MenStatistics.Caption := Menu_View[11];
      Languages1.Caption := Menu_View[12];
      English1.Caption := Menu_View[13];
      Deutsch1.Caption := Menu_View[14];
      Russian1.Caption := Menu_View[15];

      Options1.Caption := Menu_Options[1];
      OperationSystem1.Caption := Menu_Options[2];
      Options_Port.Caption := Menu_Options[3];
      Options_PnP.Caption := Menu_Options[4];
      Options_Country.Caption := Menu_Options[5];
      //PnPCustom.Caption := Menu_Options[6];
      //CountryCustom.Caption := Menu_Options[6];

      Help.Caption := Menu_Help[1];
      Help_Index.Caption := Menu_Help[2];
      SupportPage1.Caption := Menu_Help[3];
      SendEMail1.Caption := Menu_Help[4];
      Help_About.Caption := Menu_Help[5];
    end;  
  end;
end;

procedure THCFForm.ReadInits(Sender: TObject);
begin
  Try
    Reg := TRegistry.Create;
    Reg.RootKey := HKEY_LOCAL_MACHINE;
//  ---  Read User Init String
    Reg.OpenKeyReadOnly('\System\CurrentControlSet\Services\Class\Modem\' + PNP_Key + '\');
    if Reg.ValueExists('UserInit') then Edit4.Text := Reg.ReadString('UserInit') else Edit4.Text := 'Not Detected';
    Reg.CloseKey;
//  ---  Read Hidden Inits A & B
    Reg.OpenKeyReadOnly('\System\CurrentControlSet\Services\Class\Modem\' + PNP_Key + '\Init\');
    if Reg.ValueExists('1') then Edit5.Text := Copy(Reg.ReadString('1'), 1, Length(Reg.ReadString('1')) - 4) else Edit1.Text := 'Not Detected';
    if Reg.ValueExists('2') then Edit1.Text := Copy(Reg.ReadString('2'), 1, Length(Reg.ReadString('2')) - 4) else Edit1.Text := 'Not Detected';
    Reg.CloseKey;
//  --- Read Hidden Inits #1 & #2
    Reg.OpenKeyReadOnly('\System\CurrentControlSet\Services\Class\Modem\' + PNP_Key + '\Settings\Init\');
    if Reg.ValueExists('1') then Edit2.Text := Copy(Reg.ReadString('1'), 1, Length(Reg.ReadString('1')) - 1) else Edit2.Text := 'Not Detected';
    if Reg.ValueExists('2') then Edit3.Text := Copy(Reg.ReadString('2'), 1, Length(Reg.ReadString('2')) - 1) else Edit3.Text := 'Not Detected';
    Reg.CloseKey;
//  ---
  Finally
    Reg.Free;
  end;
end;

end.
